 
MAGIMAGEHEADER struct
  dwidth  dd ? 
  dheight dd ?
  format dd 4 dup (?)  ; WICPixelFormatGUID
  stride dd ?
  doffset dd ?
  cbSize dd ?
MAGIMAGEHEADER ends



    SrvCleanMgn                proto :dword
    MagnScreenRecorder         proto :dword
    GetMgnScreen               proto :dword, :dword
    InitMgnify                 proto :dword
    HostWndProc                proto :dword, :dword, :dword, :dword
    UpdateMagWindow            proto :dword
    MagSetImageScalingCallback proto :dword, :dword
    MagSetWindowSource         proto :dword, :dword, :dword, :dword, :dword
    Magimagescalingcallback1   proto C :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword
    MagUninitialize            proto 
    MagInitialize              proto
    DwmEnableComposition       proto :dword

.data
      WindowClassName  db "MagHideWin",0
      WindowTitle      db "SurfMagHideWin",0                          
      aMagcontrol      db "MagControl",0
      mgClassName      db "Magnifier",0



.code

;#####################################################

GetMgnScreen proc uses esi edi ebx  this_:dword, pBuff:dword 

    mov    esi, this_
    invoke UpdateMagWindow, this_
    invoke WaitForSingleObjectEx, mSrv.m_evntMgn, -1, FALSE
    invoke memcpy, pBuff, mSrv.m_MgnClbck, mSrv.m_Size    
    xor    eax, eax
    ret

GetMgnScreen endp

;#####################################################

MagnScreenRecorder proc uses esi edi ebx  this_:dword    

       LOCAL  retVal  : dword
       LOCAL  xsize   : dword
       LOCAL  psiz    : dword
       LOCAL  FrmCntr : dword       
       LOCAL  dwTick  : dword
       LOCAL  ThsIdk1 : dword
       LOCAL  buffrp2[100] : byte
              
       mov     FrmCntr, 0                       
       lea     esi, SrvMng
     
       invoke  InitMgnify, addr SrvMng
       
       invoke  GetTickCount
       mov     dwTick, eax
            
       invoke  OpenMvFile, this_, SrvMng.m_VidSiz
;--             
       invoke GetMgnScreen, this_, mSrv.m_CurFrame
       .if eax != 0
          mov   retVal, 261
          jmp   @@Err         
       .endif       
       
       invoke RGBCompressor,this_, mSrv.m_CurFrame, RGB_4bit       
       
       add    mSrv.m_dtPntr, sizeof  VIDEO_FILE_HEADER
            
       invoke AddInMvFile1, this_, mSrv.m_CurFrame 
      
       invoke CreateEvent, 0, 1, 0, 0
       mov    mSrv.m_evntStop, eax

;====================

       .while (1)
          invoke WaitForSingleObjectEx, mSrv.m_evntStop, mSrv.m_Delay, FALSE
          .if eax != WAIT_TIMEOUT
             .break
          .endif
         
          invoke GetMgnScreen, this_, mSrv.m_NewFrame
          .if eax == DXGI_ERROR_WAIT_TIMEOUT
             .continue
          .endif
          .if eax != 0
             mov   retVal, 261
             jmp   @@Err          
          .endif  

          invoke RGBCompressor, this_, mSrv.m_NewFrame, RGB_4bit            
          invoke UpdateMainFrame, this_, mSrv.m_CurFrame, mSrv.m_NewFrame, mSrv.m_DifFrame
                                         
          invoke AddInMvFile, this_, mSrv.m_DifFrame       

          inc   FrmCntr
       .endw       

;=====================
;       mov    mSrv.m_FlFirst, 2
;       invoke SetEvent, mSrv.m_evntNext
;-      
       invoke  GetTickCount       
       sub     eax, dwTick
       
       mov     edi, mSrv.m_pMem
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwTime, eax
       mov     ecx, "ONIK"
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwSign, ecx
       mov     eax, mSrv.m_Widh
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwWidh, eax
       mov     eax, mSrv.m_Hight
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwHeig, eax
       mov     eax, mSrv.m_Delay
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwFps, eax
       mov     eax, FrmCntr
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwFrCn, eax
       mov     eax, mSrv.m_dtPntr
       sub     eax, mSrv.m_pMem
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwSize, eax
;                                   
       mov     eax, (VIDEO_FILE_HEADER ptr [edi]).dwTime
       xor     edx, edx
       mov     ecx, 1000
       div     ecx  
       mov     edx, (VIDEO_FILE_HEADER ptr [edi]).dwSize
       shr     edx, 10
       invoke  wsprintfA, addr buffrp2, addr sztem33, eax, FrmCntr, edx            
       invoke  MessageBox, 0, addr buffrp2, addr szRerror, 0
       
       invoke  CloseMvFile, this_         
@@Fin:
       
       invoke SrvCleanMgn, esi
       mov    g_type, 0
       ret
@@Err:
       invoke GetLastError
       .if    eax == 0
          
       .endif

       jmp    @@Fin

     
MagnScreenRecorder endp

;#############################################

SrvCleanMgn proc uses esi edi ebx this_:dword

     mov      esi, this_     
     invoke   srMemManagerFree, esi
;     invoke   CloseHandle, mSrv.m_evntNext
     invoke   CloseHandle, mSrv.m_evntStop
     invoke   CloseHandle, mSrv.m_evntMgn
     invoke   free, mSrv.m_MgnClbck
     invoke   MagUninitialize
     ret


SrvCleanMgn endp

;#####################################################

InitMgnify proc uses esi edi ebx this_:dword

    LOCAL wcex : WNDCLASSEX
    LOCAL hIst : dword 
    LOCAL hwRect : RECT

    invoke   MagInitialize            
    invoke   DwmEnableComposition, 0           
    mov      esi, this_
    
    invoke srMemManagerInit, esi    
    invoke malloc, 3840*2160*4
    mov    mSrv.m_MgnClbck, eax
;    invoke CreateEvent, 0,0,0,0
;    mov    mSrv.m_evntNext, eax
    invoke CreateEvent, 0,1,0,0
    mov    mSrv.m_evntMgn, eax
    
    
    invoke GetModuleHandle, 0 
    mov    hIst, eax  
    invoke memset, addr wcex, 0, sizeof WNDCLASSEX
    mov    wcex.cbSize, sizeof WNDCLASSEX 
    mov    wcex.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
    mov    wcex.lpfnWndProc,  offset HostWndProc
    mov    eax, hIst
    mov    wcex.hInstance, eax       
    mov    wcex.hbrBackground, COLOR_WINDOWFRAME 
    mov    wcex.lpszClassName, offset WindowClassName
    invoke RegisterClassEx, addr wcex
      
    mov    hwRect.top,  0
    invoke GetSystemMetrics, SM_CYSCREEN
    mov    hwRect.bottom, eax   
    mov    mSrv.m_Hight, eax         
    mov    hwRect.left, 0
    invoke GetSystemMetrics, SM_CXSCREEN
    mov    hwRect.right, eax 
    mov    mSrv.m_Widh, eax
                                          
    mov    eax, mSrv.m_Hight
    mov    ecx, mSrv.m_Widh
    mul    ecx
    shl    eax, 2
    mov    mSrv.m_Size, eax 
                        
    invoke CreateWindowExA, 8080020h, addr WindowClassName, addr WindowTitle, 82000000h, 0,0, hwRect.right, hwRect.bottom, 0, 0, hIst, 0 
    mov    (SERVER_MANAGER ptr [esi]).m_hwndHost, eax
    .if dword ptr (SERVER_MANAGER ptr [esi]).m_hwndHost == 0    
        xor  eax, eax
        jmp  @@frr
    .endif
               
    invoke GetClientRect, (SERVER_MANAGER ptr [esi]).m_hwndHost, addr hwRect
                 
    invoke CreateWindowExA, 0, offset mgClassName, offset aMagcontrol, 50000000h, hwRect.left, hwRect.top, hwRect.right, hwRect.bottom, (SERVER_MANAGER ptr [esi]).m_hwndHost, 0, 0,0
    mov    (SERVER_MANAGER ptr [esi]).m_hwndMag, eax
    .if dword ptr (SERVER_MANAGER ptr [esi]).m_hwndMag == 0
        xor  eax, eax    
        jmp  @@frr
    .endif

    invoke MagSetImageScalingCallback, (SERVER_MANAGER ptr [esi]).m_hwndMag, offset Magimagescalingcallback1
@@frr:
    ret

InitMgnify endp

;#####################################################

HostWndProc  proc uses esi edi ebx hWnd:dword, message:dword, wParam:dword, lParam:dword 
               
    .if  message == WM_DESTROY                                                                         
      invoke  CallWindowProc, addr DefWindowProc,  hWnd, WM_DESTROY, ebx, ebp                                                                                                
    .elseif message == WM_CREATE
      invoke  SetLayeredWindowAttributes, hWnd, 0, 0ffh, 2  
    .elseif message == WM_NCDESTROY 
      invoke  CallWindowProc, addr DefWindowProc,  hWnd, WM_NCDESTROY, wParam, lParam
    .else
      invoke DefWindowProc, hWnd, message, wParam, lParam
    .endif                    
    ret

HostWndProc endp

;#####################################################

UpdateMagWindow proc  uses esi edi ebx this_:dword
               
    LOCAL sourceRect : RECT           
       
    mov    esi, this_
    mov    sourceRect.top,  0
    invoke GetSystemMetrics, SM_CYSCREEN
    mov    sourceRect.bottom,eax
    mov    sourceRect.left, 0
    invoke GetSystemMetrics, SM_CXSCREEN
    mov    sourceRect.right, eax                                      
    invoke MagSetWindowSource, (SERVER_MANAGER ptr [esi]).m_hwndMag, sourceRect.left, sourceRect.top, sourceRect.right, sourceRect.bottom     
    invoke SetWindowPos, (SERVER_MANAGER ptr [esi]).m_hwndHost, -1, 0, 0, 0, 0,  SWP_NOSIZE or SWP_NOACTIVATE or SWP_NOMOVE 
    invoke InvalidateRect, (SERVER_MANAGER ptr [esi]).m_hwndMag, 0, 1       
    
    ret

UpdateMagWindow endp

;#####################################################

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
Magimagescalingcallback1 proc C hwnd:dword, srcdata:dword, srcheader:dword, destdata:dword, destheader:dword, unclipped:dword, clipped:dword, dirty:dword


;    mov    ecx, [esp+4]  ; windh
;    mov    ecx, [esp+8]  ; srcdata
;    mov    ecx, [esp+12] ; MAGIMAGEHEADER.width
;    mov    ecx, [esp+16] ; MAGIMAGEHEADER.height
;    mov    ecx, [esp+20] ; MAGIMAGEHEADER.WICPixelFormatGUID[0]
;    mov    ecx, [esp+24] ; MAGIMAGEHEADER.WICPixelFormatGUID[4]    
;    mov    ecx, [esp+28] ; MAGIMAGEHEADER.WICPixelFormatGUID[8]  
;    mov    ecx, [esp+32] ; MAGIMAGEHEADER.WICPixelFormatGUID[12]
;    mov    ecx, [esp+36] ; MAGIMAGEHEADER.stride = widh in byte   
;    mov    ecx, [esp+40] ; MAGIMAGEHEADER.offset   
;    mov    ecx, [esp+44] ; MAGIMAGEHEADER.cbSize   
;    mov    ecx, [esp+48] ; destdata   
;    mov    ecx, [esp+52] ; MAGIMAGEHEADER.width   
;    mov    ecx, [esp+56] ; MAGIMAGEHEADER.height   
;    mov    ecx, [esp+60] ; MAGIMAGEHEADER.WICPixelFormatGUID[0]   
;    mov    ecx, [esp+64] ; MAGIMAGEHEADER.WICPixelFormatGUID[4]  
;    mov    ecx, [esp+68] ; MAGIMAGEHEADER.WICPixelFormatGUID[8]    
;    mov    ecx, [esp+72] ; MAGIMAGEHEADER.WICPixelFormatGUID[12]  
;    mov    ecx, [esp+76] ; MAGIMAGEHEADER.stride = widh in byte    
;    mov    ecx, [esp+80] ; MAGIMAGEHEADER.offset    
;    mov    ecx, [esp+84] ; MAGIMAGEHEADER.cbSize
;    mov    ecx, [esp+88] ; unclipped ; The coordinates of the scaled version of the source bitmap.
;    mov    ecx, [esp+92] ; clipped   ; The coordinates of the window to which the scaled bitmap is clipped.
;    mov    ecx, [esp+96] ; dirty     ; The region that needs to be refreshed.
    
    lea    edx, [esp+4] ; hwnd
    add    edx, 4       ; 
    mov    eax, [edx]   ; srcdata
    add    edx, 4       ; srcheader 

    invoke memcpy, SrvMng.m_MgnClbck, eax, (MAGIMAGEHEADER ptr [edx]).cbSize
    invoke SetEvent,SrvMng.m_evntMgn
    xor    eax, eax
    ret

Magimagescalingcallback1 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
;###################################################

