


.code

;#############################################

CloseMvFile proc uses esi edi this_:dword

       mov    esi, this_
       invoke UnmapViewOfFile, mSrv.m_pMem
       invoke CloseHandle, mSrv.m_hMapping        
       invoke CloseHandle, mSrv.m_hFile  
       ret

CloseMvFile endp

;#############################################

OpenMvFile proc uses  esi edi ebx this_:dword, dwSize:dword

       LOCAL RetVal : dword
       
       mov     RetVal, 0
       mov     esi, this_
       invoke  CreateFile, addr mSrv.m_FileName, GENERIC_READ OR GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL,0
       .if eax == -1                
          invoke GetLastError          
          mov    RetVal, eax
          jmp    @@Fin
       .endif
       mov     mSrv.m_hFile, eax  

       mov  eax, dwSize
       mov  mSrv.m_VidSiz, eax

       invoke  CreateFileMapping, mSrv.m_hFile, 0, PAGE_READWRITE, 0, dwSize, 0
       .if eax == 0
          invoke GetLastError   
          mov    RetVal, eax
          jmp    @@Fin        
       .endif
       mov     mSrv.m_hMapping, eax  
       
       invoke  MapViewOfFile, mSrv.m_hMapping, FILE_MAP_WRITE, 0, 0, 0   
       mov     mSrv.m_pMem, eax
       mov     mSrv.m_dtPntr, eax
@@Fin:
       mov     eax, RetVal                     
       ret

OpenMvFile endp

;#############################################

AddInMvFile1 proc uses esi edi ebx this_:dword, inDat:dword

       LOCAL  psiz : dword
       
       mov    eax, mSrv.m_Size
       mov    edi, mSrv.m_ZlibBuf
       mov    (NET_COMPRES_HEADER ptr [edi]).UnPackSiz, eax
       add    edi, sizeof NET_COMPRES_HEADER
       mov    psiz, 3840*2160*4 
       invoke compress2, edi, addr psiz, inDat, mSrv.m_Size, 9 
       
       sub    edi, sizeof NET_COMPRES_HEADER
       mov    eax, psiz       
       mov    (NET_COMPRES_HEADER ptr [edi]).PackSize, eax                                    
       add    psiz, sizeof NET_COMPRES_HEADER       
       invoke memcpy, mSrv.m_dtPntr, mSrv.m_ZlibBuf, psiz                      
       mov    eax, psiz
       add    mSrv.m_dtPntr, eax  
       ret

AddInMvFile1 endp       
       
;#############################################

AddInMvFile proc uses esi edi ebx this_:dword, inDat:dword

       LOCAL  psiz : dword
       LOCAL  xsiz : dword

       mov    esi, this_ 

       mov    eax, mSrv.m_Size
       mov    xsiz, eax
       add    xsiz, sizeof DIFF_FRAME

       mov    eax, mSrv.m_Size
       mov    ecx, 4*8
       xor    edx, edx
       div    ecx    
       add    xsiz, eax
       
       mov    eax, xsiz
       mov    edi, mSrv.m_ZlibBuf
       mov    (NET_COMPRES_HEADER ptr [edi]).UnPackSiz, eax       
       add    edi, sizeof NET_COMPRES_HEADER
       
       mov    psiz, 3840*2160*4       
       invoke compress2, edi, addr psiz, inDat, xsiz, COPMR_LEVEL 
       
       sub    edi, sizeof NET_COMPRES_HEADER
       mov    eax, psiz
       mov    (NET_COMPRES_HEADER ptr [edi]).PackSize, eax                                    
       
       add    psiz, sizeof NET_COMPRES_HEADER
       
       mov    eax, psiz
       add    eax, mSrv.m_dtPntr 
       mov    ecx, mSrv.m_pMem
       add    ecx, mSrv.m_VidSiz  
       .if  eax < ecx        
          invoke memcpy, mSrv.m_dtPntr, mSrv.m_ZlibBuf, psiz             
          mov    eax, psiz
          add    mSrv.m_dtPntr, eax     
          xor    eax, eax        
       .else
         invoke SetEvent, mSrv.m_evntStop
         mov    eax, -1
       .endif               
       
       ret
       
AddInMvFile endp 

;#############################################