SrvCleanD3D09 proto :dword




.code

;#############################################

D3D09ScreenRecorder proc uses esi edi ebx  this_:dword    

       LOCAL  retVal  : dword
       LOCAL  xsize   : dword
       LOCAL  psiz    : dword
       LOCAL  FrmCntr : dword       
       LOCAL  dwTick  : dword
       LOCAL  ThsIdk1 : dword
       LOCAL  buffrp2[100] : byte
       LOCAL  CurrentDesktop : dword
       LOCAL  DesktopAttached : dword
              
       mov     FrmCntr, 0

       mov    DesktopAttached, 0
       invoke OpenInputDesktop, 0, FALSE, GENERIC_ALL
       mov    CurrentDesktop, eax
       .if (!CurrentDesktop)            
          mov  retVal, DUPL_RETURN_ERROR_EXPECTED
          jmp  @@Err
       .endif
        
       invoke SetThreadDesktop, CurrentDesktop
       .if  eax != 0
          mov    DesktopAttached, 1
       .endif
       invoke CloseDesktop, CurrentDesktop
       .if (!DesktopAttached)            
          mov  retVal, DUPL_RETURN_ERROR_EXPECTED
          jmp  @@Err
       .endif
                       
       lea     esi, SrvMng
       
       invoke InitD3D09, addr SrvMng
       
       invoke  GetTickCount
       mov     dwTick, eax
            
       invoke  OpenMvFile, this_, SrvMng.m_VidSiz
;--             
       invoke GetD3d09Screen, this_, mSrv.m_CurFrame
       .if eax != 0
          mov   retVal, 261
          jmp   @@Err         
       .endif       
       invoke RGBCompressor,this_, mSrv.m_CurFrame, RGB_4bit       
       
       add    mSrv.m_dtPntr, sizeof  VIDEO_FILE_HEADER
            
       invoke AddInMvFile1, this_, mSrv.m_CurFrame 
      
       invoke CreateEvent, 0, 1, 0, 0
       mov    mSrv.m_evntStop, eax

;====================

       .while (1)
          invoke WaitForSingleObjectEx, mSrv.m_evntStop, mSrv.m_Delay, FALSE
          .if eax != WAIT_TIMEOUT
             .break
          .endif
         
          invoke GetD3d09Screen, this_, mSrv.m_NewFrame
          .if eax == DXGI_ERROR_WAIT_TIMEOUT
             .continue
          .endif
          .if eax != 0
             mov   retVal, 261
             jmp   @@Err          
          .endif  

          invoke RGBCompressor, this_, mSrv.m_NewFrame, RGB_4bit            
          invoke UpdateMainFrame, this_, mSrv.m_CurFrame, mSrv.m_NewFrame, mSrv.m_DifFrame
                                         
          invoke AddInMvFile, this_, mSrv.m_DifFrame       

          inc   FrmCntr
       .endw       

;=====================
;       mov    mSrv.m_FlFirst, 2
;       invoke SetEvent, mSrv.m_evntNext
;-      
       invoke  GetTickCount       
       sub     eax, dwTick
       
       mov     edi, mSrv.m_pMem
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwTime, eax
       mov     ecx, "ONIK"
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwSign, ecx
       mov     eax, mSrv.m_Widh
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwWidh, eax
       mov     eax, mSrv.m_Hight
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwHeig, eax
       mov     eax, mSrv.m_Delay
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwFps, eax
       mov     eax, FrmCntr
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwFrCn, eax
       mov     eax, mSrv.m_dtPntr
       sub     eax, mSrv.m_pMem
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwSize, eax
;                                   
       mov     eax, (VIDEO_FILE_HEADER ptr [edi]).dwTime
       xor     edx, edx
       mov     ecx, 1000
       div     ecx  
       mov     edx, (VIDEO_FILE_HEADER ptr [edi]).dwSize
       shr     edx, 10
       invoke  wsprintfA, addr buffrp2, addr sztem33, eax, FrmCntr, edx            
       invoke  MessageBox, 0, addr buffrp2, addr szRerror, 0
       
       invoke  CloseMvFile, this_         
@@Fin:
       
       invoke SrvCleanD3D09, esi
       mov    g_type, 0
       ret
@@Err:
       invoke GetLastError
       .if    eax == 0
          
       .endif

       jmp    @@Fin

     
D3D09ScreenRecorder endp

;#############################################

SrvCleanD3D09 proc uses esi edi ebx this_:dword

     mov      esi, this_     
     invoke   srMemManagerFree, esi
     invoke   CloseHandle, mSrv.m_evntStop          
     ret

SrvCleanD3D09 endp

;#############################################

InitD3D09 proc uses esi edi ebx this_:dword
           
           LOCAL   pMode     : D3DDISPLAYMODE
           LOCAL   pPrsntPrm : D3DPRESENT_PARAMETERS
                      
           mov      esi, this_
           invoke   Direct3DCreate9, 32
           mov      (SERVER_MANAGER ptr [esi]).m_D3D09obj, eax        
           invoke   memset, addr pMode, 0, sizeof D3DDISPLAYMODE        
           coinvoke (SERVER_MANAGER ptr [esi]).m_D3D09obj, IDirect3D9, GetAdapterDisplayMode, D3DADAPTER_DEFAULT, addr pMode
      
           invoke   memset, addr pPrsntPrm, 0, sizeof D3DPRESENT_PARAMETERS

           mov      pPrsntPrm.Windowed, 1
           mov      pPrsntPrm.BackBufferCount, 1
        
           mov      eax, pMode.dHeight
           mov      pPrsntPrm.BackBufferHeight, eax
           mov      (SERVER_MANAGER ptr [esi]).m_Hight, eax

           mov      ecx, pMode.dWidth
           mov      pPrsntPrm.BackBufferWidth, ecx
           mov      (SERVER_MANAGER ptr [esi]).m_Widh, ecx
           mul      ecx
           shl      eax, 2
           mov      (SERVER_MANAGER ptr [esi]).m_Size, eax
                      
           mov      pPrsntPrm.SwapEffect, D3DSWAPEFFECT_DISCARD
           mov      pPrsntPrm.hDeviceWindow, 0
               
           coinvoke (SERVER_MANAGER ptr [esi]).m_D3D09obj, IDirect3D9, CreateDevice, D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, 0, D3DCREATE_HARDWARE_VERTEXPROCESSING, addr pPrsntPrm, addr (SERVER_MANAGER ptr [esi]).m_Device     
           coinvoke (SERVER_MANAGER ptr [esi]).m_Device, IDirect3DDevice9, CreateOffscreenPlainSurface, pMode.dWidth, pMode.dHeight, D3DFMT_A8R8G8B8, D3DPOOL_SYSTEMMEM, addr (SERVER_MANAGER ptr [esi]).m_GDIImage, 0  ; 
           
           invoke   srMemManagerInit, esi    
;           invoke   CreateEvent, 0,0,0,0
;           mov      mSrv.m_evntNext, eax
           
           mov      eax, esi
           ret

InitD3D09 endp           

;#############################################

GetD3d09Screen  proc uses esi edi ebx this_:dword, pBuf:dword
  
      
     LOCAL  rc          : D3DLOCKED_RECT  
     LOCAL  pIdentifier : D3DADAPTER_IDENTIFIER9
        
     mov      esi,this_                                                                 
     coinvoke (SERVER_MANAGER ptr [esi]).m_Device, IDirect3DDevice9, GetFrontBufferData, 0, (SERVER_MANAGER ptr [esi]).m_GDIImage              
     coinvoke (SERVER_MANAGER ptr [esi]).m_GDIImage, IDirect3DSurface9, LockRect, addr rc, 0, 0
     mov      eax, rc.Pitch
     mov      ecx, (SERVER_MANAGER ptr [esi]).m_Hight
     mul      ecx
     mov      ebx, eax   
     invoke   memcpy, pBuf, rc.pBits, ebx 
     coinvoke (SERVER_MANAGER ptr [esi]).m_GDIImage, IDirect3DSurface9, UnlockRect                  
     ret
    
GetD3d09Screen endp   

;#############################################
