


.code

;######################################################################

ScreenPlayer2 proc uses esi edi ebx this_:dword

     
    LOCAL hWin         : dword
    LOCAL hCur         : dword  
    LOCAL msg          : MSG
    LOCAL FirstTime    : dword
    LOCAL Occluded     : dword
    LOCAL RetVal       : dword 
    LOCAL Wc           : WNDCLASSEXW            
    LOCAL ThreadId     : dword
    LOCAL ThrHandle    : dword
    LOCAL  Wtx         : dword
    LOCAL  Wty         : dword      
    LOCAL  Wwd         : dword
    LOCAL  Wht         : dword
 
 
    mov    ebx,  this_
;-
    invoke clMemManagerInit, ebx 
;-
    invoke CreateEvent, 0, 0, 1, 0
    mov    mCln.m_evntGo, eax              
;-                 
    invoke D3d11CreateFrmDescrp, ebx  
 
    invoke CreateD3d11WindowObj, ebx      

    invoke LoadCursorA, 0, IDC_ARROW
    mov    hCur, eax

    invoke memset, addr Wc, 0, sizeof WNDCLASSEXW  
    mov    Wc.cbSize, sizeof WNDCLASSEX
    mov    Wc.style,  CS_HREDRAW or CS_VREDRAW
    mov    Wc.lpfnWndProc, offset D3d11WndProc
    mov    eax, hInstance
    mov    Wc.hInstance, eax
    mov    eax, hCur
    mov    Wc.hCursor, eax
    mov    Wc.lpszClassName, offset  ClassName
    invoke RegisterClassEx, addr  Wc        
    mov    Wwd, 1024
    mov    Wht, 720                                                                    
    invoke GetSystemMetrics, SM_CXSCREEN
    invoke TopXY, Wwd, eax
    mov    Wtx, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    invoke TopXY, Wht, eax
    mov    Wty, eax
    invoke CreateWindowEx, 0, offset ClassName, offset WindowName, WS_OVERLAPPEDWINDOW, Wtx, Wty, Wwd, Wht, 0, 0, hInstance, this_
    mov    hWin, eax                           
    .if (!hWin)     
        xor   eax,eax                
        jmp   @@fin
    .endif            
    invoke DestroyCursor, hCur
    invoke ShowWindow, hWin, SW_SHOWNORMAL
    invoke UpdateWindow, hWin    
    mov    FirstTime, 1
    mov    Occluded, 1
    mov    msg.message, 0
    .while (msg.message != WM_QUIT)    
        mov    RetVal, DUPL_RETURN_SUCCESS
        invoke PeekMessage, addr msg, 0, 0, 0, PM_REMOVE
        .if (eax)        
            .if (msg.message == OCCLUSION_STATUS_MSG)                            
                mov   Occluded, 0            
            .else                            
                invoke TranslateMessage, addr msg
                invoke DispatchMessage, addr msg
            .endif                
        .elseif (FirstTime)                                                      
           mov    FirstTime, 0                                   
           invoke D3d11ImplementWin, ebx, hWin  
           mov    RetVal, eax
           .if (RetVal == DUPL_RETURN_SUCCESS)             
             invoke CreateD3d11FramFactory, ebx                                              
             invoke CreateEvent, 0, 1, 0, 0        
             mov    mCln.m_EvntThrStop , eax                                                              
             invoke CreateThread, 0, 0, addr D3d11FrmBuilder, ebx, 0, addr ThreadId   
             mov    ThrHandle, eax                                                         
             mov    RetVal, 0
           .endif            
           mov  Occluded, 1        
        .else                            
           .if (!Occluded)            
              invoke D3d11UpdateWindow, ebx, addr Occluded 
              mov    RetVal, eax
           .endif
        .endif        
        .if (RetVal != DUPL_RETURN_SUCCESS)                  
           .break
        .endif
    .endw    
    invoke SetEvent, mCln.m_EvntThrStop   
    .if (eax)       
        invoke WaitForSingleObjectEx, ThrHandle, 0, FALSE
    .endif    
    
    invoke CloseHandle, ThrHandle
     
    
;    .if (msg.message == WM_QUIT)    
;        mov  eax, msg.wParam        
;    .endif    
@@fin:
    ret

ScreenPlayer2 endp

;#######################################

D3d11FrmBuilder proc uses esi edi ebx this_:dword

    LOCAL  RetVal                    : dword    
    LOCAL  SharedSurf                : dword ; ID3D11Texture2D*
    LOCAL  KeyMutex                  : dword ; IDXGIKeyedMutex*
    LOCAL  pNewSurf                  : dword
                   
    mov      ebx, this_             
;===== 
    mov      SharedSurf, 0 
    coinvoke mCln.m_Device2, ID3D11Device, OpenSharedResource, mCln.m_ShareHandle, addr IID_ID3D11Texture2D, addr SharedSurf    
    .if (eax != 0)    
        mov  RetVal, DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@Exit
    .endif
         
    mov    KeyMutex, 0
    coinvoke SharedSurf, ID3D11Texture2D, QueryInterface, addr IID_IDXGIKeyedMutex, addr KeyMutex    
    .if ( eax != 0)   
        mov  RetVal, DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@Exit
    .endif
;======                                          
    .while (1)    
       invoke WaitForSingleObjectEx, mCln.m_EvntThrStop, 0, FALSE   
       .if eax != WAIT_TIMEOUT
          .break
       .endif        
        coinvoke KeyMutex, IDXGIKeyedMutex, AcquireSync, 0, 0, 100        
        .if (eax == WAIT_TIMEOUT)                    
           .continue        
        .endif                
;--                                   
        invoke  WaitForSingleObject,  mCln.m_evntGo, mCln.m_Delay                  
        .if  dword ptr mCln.m_fFirst == 0    

           invoke   ClnLoadCurrFrame,  ebx    
           invoke   D3d11TextureFromBitmap, ebx, SharedSurf, addr pNewSurf       
           coinvoke mCln.m_DeviceContext2, ID3D11DeviceContext, CopyResource, SharedSurf, pNewSurf             
           coinvoke pNewSurf, IUnknown,Release               
           mov     mCln.m_fFirst, 1      
        .else
           invoke  ClntLoadNextFrame, ebx       
           push     eax
           invoke   D3d11TextureFromBitmap, ebx, SharedSurf, addr pNewSurf                           
           coinvoke mCln.m_DeviceContext2, ID3D11DeviceContext, CopyResource, SharedSurf, pNewSurf          
           coinvoke pNewSurf, IUnknown,Release                 
           pop      eax
           .if eax != 0
              invoke ClnCloseVidFile, ebx      
              coinvoke KeyMutex, IDXGIKeyedMutex, ReleaseSync, 1, 0 
              .break
           .endif              
        .endif       
;--  
        coinvoke KeyMutex, IDXGIKeyedMutex, ReleaseSync, 1, 0        
        .if (eax != 0)                                  
           .break
        .endif                 
    .endw
@@Exit:
     mov    g_type, 0
    .if (SharedSurf)    
        coinvoke SharedSurf, IUnknown, Release
    .endif
    .if (KeyMutex)    
       coinvoke KeyMutex, IUnknown, Release
    .endif
    invoke FreeScreenPlayer2, ebx      
    xor   eax, eax
    ret

D3d11FrmBuilder endp

;##########################################

CreateD3d11FramFactory proc uses esi edi ebx this_:dword 

       LOCAL  SampDesc        : D3D11_SAMPLER_DESC 
       LOCAL  FeatureLevel    : dword            
       LOCAL  hr              : dword          
                                                                   
       mov    ebx, this_                                                      
       xor    esi, esi
       .while esi < 3        
          invoke D3D11CreateDevice, 0, DriverTypes[esi*4], 0, 0, addr FeatureLevels, 4, D3D11_SDK_VERSION, addr mCln.m_Device2, addr FeatureLevel, addr mCln.m_DeviceContext2
          .if eax == 0                    
             .break
          .endif
          inc  esi
       .endw 
       mov  eax, DUPL_RETURN_SUCCESS   
@@Erl:       
       ret 
       

CreateD3d11FramFactory   endp

;##################################################

D3d11CreateFrmDescrp proc  uses  esi edi ebx this_:dword
      
      LOCAL   desc     : D3D11_TEXTURE2D_DESC
      LOCAL   decRect  : RECT
      
      mov     ebx, this_
      invoke  GetDC, 0
      mov     esi, eax                              					
		  invoke  GetDeviceCaps, esi, HORZRES
		  mov     desc.dWidth, eax
		  invoke  GetDeviceCaps, esi, VERTRES 
		  mov     desc.dHeight, eax		  
		  
		  mov     desc.ArraySize, 1
		  mov     desc.MipLevels, 1
		  mov     desc.SampleDesc.Count, 1
		  mov     desc.SampleDesc.Quality, 0
      mov     desc.Format, DXGI_FORMAT_B8G8R8A8_UNORM         
      mov     desc.Usage, D3D11_USAGE_DEFAULT        
      mov     desc.CPUAccessFlags, 0    
      mov     desc.BindFlags, D3D11_BIND_RENDER_TARGET or D3D11_BIND_SHADER_RESOURCE
      mov     desc.MiscFlags, D3D11_RESOURCE_MISC_SHARED_KEYEDMUTEX  
      invoke  DeleteDC, esi
      invoke  memcpy, addr mCln.m_Deskr, addr desc, sizeof D3D11_TEXTURE2D_DESC   
      invoke  GetDesktopWindow
      mov     edx, eax
      invoke  GetWindowRect, edx, addr  decRect
      invoke  memcpy, addr mCln.m_DeskRct, addr decRect, sizeof RECT    
      ret

D3d11CreateFrmDescrp endp

;######################################################################

D3d11TextureFromBitmap proc uses esi edi ebx this_:dword, pSrgSrf:dword, pOut:dword

     LOCAL  desc              : D3D11_TEXTURE2D_DESC
     LOCAL  subResource       : D3D11_SUBRESOURCE_DATA
      
     mov      ebx, this_
     invoke   memset, addr desc, 0, sizeof desc     
     invoke   GetDC, 0     
     mov      esi, eax          
     invoke   GetDeviceCaps, esi, HORZRES
		 mov      desc.dWidth, eax     
     invoke   GetDeviceCaps, esi, VERTRES 
     mov      desc.dHeight, eax
     mov      desc.MipLevels, 1
     mov      desc.ArraySize, 1
     mov      desc.Format, DXGI_FORMAT_B8G8R8A8_UNORM 
     mov      desc.SampleDesc.Count, 1
     mov      desc.Usage, D3D11_USAGE_DEFAULT
     mov      desc.BindFlags, D3D11_BIND_SHADER_RESOURCE
     mov      desc.CPUAccessFlags, 0  
     mov      eax, mCln.m_CurFrame                  
     mov      subResource.pSysMem, eax
     mov      eax, desc.dWidth
     shl      eax, 2          
     mov      subResource.SysMemPitch, eax
     mov      subResource.SysMemSlicePitch, 0
     coinvoke mCln.m_Device2, ID3D11Device, CreateTexture2D, addr desc, addr subResource, pOut      
     ret

D3d11TextureFromBitmap endp

;#######################################

D3d11WndProc proc hWnd:dword, message:dword, wParam:dword, lParam:dword
     

        invoke  GetProp, hWnd, addr sProp1
        mov     ebx, eax        
        .if message == WM_DESTROY                
            invoke PostQuitMessage, 0        
        .elseif message == WM_CREATE  
            mov    ebx, lParam
            mov    ebx, [ebx]
            invoke SetProp, hWnd, addr sProp1, ebx
        .elseif message == WM_CLOSE   
            invoke PostQuitMessage, 0   
        .elseif message == WM_SIZE                                        
            invoke D3d11ResizeSwapChain, ebx  
        .else
            invoke DefWindowProc, hWnd, message, wParam, lParam
            jmp    @@exf
        .endif
        xor eax, eax
@@exf:
        ret

D3d11WndProc endp

;##########################################

D3d11UpdateWindow proc uses esi edi ebx this_:dword,  Occluded:dword 

    LOCAL RetVal         : dword
    LOCAL hr             : dword    
    LOCAL FrameDesc      : D3D11_TEXTURE2D_DESC
    LOCAL ShaderResource : dword   ; ID3D11ShaderResourceView
    LOCAL ShaderDesc     : D3D11_SHADER_RESOURCE_VIEW_DESC
    LOCAL Stride         : dword
    LOCAL dOffset        : dword
    LOCAL BufferDesc     : D3D11_BUFFER_DESC
    LOCAL VertexBuffer   : dword   ; ID3D11Buffer
    LOCAL InitData       : D3D11_SUBRESOURCE_DATA 
    

    mov      ebx,  this_
    .if dword ptr mCln.m_DeviceContext2 == 0
       jmp   @@Ert
    .endif
    coinvoke mCln.m_KeyMutex, IDXGIKeyedMutex, AcquireSync, 1, 0, 100
    mov      hr, eax
    .if (hr == WAIT_TIMEOUT)
        mov  eax, DUPL_RETURN_SUCCESS
        jmp   @@Ert
    
    .elseif (hr != 0)
       mov eax, DUPL_RETURN_ERROR_UNEXPECTED
        jmp   @@Ert
    .endif
    invoke   D3d11WinDrawTexture, ebx, mCln.m_SharedSurf
    mov      RetVal, DUPL_RETURN_SUCCESS
    coinvoke mCln.m_KeyMutex, IDXGIKeyedMutex, ReleaseSync, 0, 0
    mov      hr, eax
    .if hr != 0 
        mov  eax, DUPL_RETURN_SUCCESS
        jmp   @@Ert    
    .endif

    .if (RetVal == DUPL_RETURN_SUCCESS)    
        coinvoke mCln.m_SwapChain, IDXGISwapChain1, Present, 1, 0
        mov      hr, eax
        .if ( hr == DXGI_STATUS_OCCLUDED)        
            mov   ecx, Occluded
            mov   eax, 1
            mov   [ecx], eax     
        .elseif (hr != 0)        
            mov   eax, DUPL_RETURN_ERROR_UNEXPECTED
            jmp   @@Ert  
        .endif
    .endif
    mov  eax, RetVal
@@Ert:
    ret

D3d11UpdateWindow endp

;#######################################

D3d11ResizeSwapChain proc uses esi edi ebx this_:dword

    LOCAL  WindowRect : RECT
    LOCAL  dWidth   : dword
    LOCAL  dHeight  : dword
    LOCAL  SwapChainDesc : DXGI_SWAP_CHAIN_DESC
    LOCAL  RetVal : dword
    LOCAL  hr : dword
    LOCAL  BackBuffer : dword
        
    mov   ebx, this_
    .if dword ptr   mCln.m_WindowHandle == 0  
       jmp      @@Ert
    .endif
    
    .if (dword ptr mCln.m_RTV)    
        coinvoke mCln.m_RTV, IUnknown, Release
        mov   mCln.m_RTV, 0
    .endif
  
    invoke GetClientRect, mCln.m_WindowHandle, addr WindowRect
    mov    eax, WindowRect.right
    sub    eax, WindowRect.left
    mov    dWidth, eax
    mov    eax, WindowRect.bottom
    sub    eax, WindowRect.top
    mov    dHeight, eax
     
    coinvoke mCln.m_SwapChain, IDXGISwapChain1, GetDesc, addr SwapChainDesc
    mov  hr, eax
 
    coinvoke mCln.m_SwapChain, IDXGISwapChain1,ResizeBuffers, SwapChainDesc.BufferCount, dWidth, dHeight, SwapChainDesc.BufferDesc.Format, SwapChainDesc.Flags
    mov  hr, eax
      
    invoke D3d11MakeRTV, this_
    mov   RetVal, eax
    .if (RetVal != DUPL_RETURN_SUCCESS)
        mov  eax, RetVal
        jmp  @@Ert
    .endif 
    invoke D3d11SetViewPort, mCln.m_DeviceContext, dWidth, dHeight
    mov    eax, RetVal
@@Ert:
    ret

D3d11ResizeSwapChain endp

;##########################################

D3d11MakeRTV proc uses esi edi ebx this_:dword
           
    LOCAL    BackBuffer : dword ; ID3D11Texture2D
    LOCAL    hr : dword
          
    mov      ebx, this_
    coinvoke mCln.m_SwapChain, IDXGISwapChain1, GetBuffer, 0, addr IID_ID3D11Texture2D, addr BackBuffer
    mov      hr, eax

    coinvoke mCln.m_Device, ID3D11Device, CreateRenderTargetView, BackBuffer, 0, addr mCln.m_RTV
    mov      hr, eax
    coinvoke BackBuffer,ID3D11Texture2D, Release

    coinvoke mCln.m_DeviceContext, ID3D11DeviceContext, OMSetRenderTargets, 1, addr mCln.m_RTV, 0
    mov      eax, DUPL_RETURN_SUCCESS
    ret

D3d11MakeRTV endp

;##########################################

D3d11SetViewPort  proc uses esi edi ebx pDevCnt:dword, dWidth:dword, dHeight:dword
                              

      LOCAL  VP       :  D3D11_VIEWPORT  
      LOCAL  tmph    :  dword 
      LOCAL  tmpl    :  dword 
 
                                                 
      mov     eax, dWidth
      mov     dword ptr tmph, eax
      mov     dword ptr tmpl, 0
      fild    tmph
      fstp    VP.dWidth
      mov     ecx, dHeight
      mov     dword ptr tmph, ecx   
      mov     dword ptr tmpl, 0     
      fild    tmph
      fstp    VP.dHeight
      fldz
      fstp    VP.MinDepth
      fld1
      fstp    VP.MaxDepth
      fldz
      fstp    VP.TopLeftX
      fldz
      fstp    VP.TopLeftY                 
      coinvoke pDevCnt, ID3D11DeviceContext, RSSetViewports, 1, addr VP                        
      ret

D3d11SetViewPort endp

;##########################################

D3d11ImplementWin proc uses esi edi ebx this_:dword, Window:dword 

    LOCAL hr             : dword
    LOCAL DxgiDevice     : dword ; IDXGIDevice*
    LOCAL DxgiAdapter    : dword ; IDXGIAdapter*
    LOCAL FeatureLevel   : dword
    LOCAL WindowRect     : RECT
    LOCAL dWidth         : dword
    LOCAL dHeight        : dword
    LOCAL SwapChainDesc  : DXGI_SWAP_CHAIN_DESC1
    LOCAL RetVal         : dword
    LOCAL SampDesc       : D3D11_SAMPLER_DESC
    LOCAL DXGIResource   : dword ;IDXGIResource*
    LOCAL BlendStateDesc : D3D11_BLEND_DESC
    
    mov   ebx, this_
    mov   eax, Window
    mov   mCln.m_WindowHandle, eax

    coinvoke  mCln.m_Factory, IDXGIFactory2, RegisterOcclusionStatusWindow, mCln.m_WindowHandle, OCCLUSION_STATUS_MSG, addr mCln.m_OcclusionCookie
    mov   hr, eax
    .if (hr != 0)
        mov  RetVal, DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@retm
    .endif

    invoke GetClientRect, mCln.m_WindowHandle, addr WindowRect

    mov    eax, WindowRect.right
    sub    eax, WindowRect.left
    mov    dWidth, eax

    mov    eax, WindowRect.bottom
    sub    eax, WindowRect.top
    mov    dHeight, eax
            
    invoke memset, addr SwapChainDesc, 0, sizeof SwapChainDesc

    mov   SwapChainDesc.SwapEffect, DXGI_SWAP_EFFECT_FLIP_SEQUENTIAL
    mov   SwapChainDesc.BufferCount, 2
    mov   eax, dWidth
    mov   SwapChainDesc.dWidth, eax
    mov   eax, dHeight
    mov   SwapChainDesc.dHeight, eax
    mov   SwapChainDesc.Format, DXGI_FORMAT_B8G8R8A8_UNORM
    mov   SwapChainDesc.BufferUsage, DXGI_USAGE_RENDER_TARGET_OUTPUT
    mov   SwapChainDesc.SampleDesc.Count, 1
    mov   SwapChainDesc.SampleDesc.Quality,  0
    
    
   coinvoke  mCln.m_Factory,IDXGIFactory2,CreateSwapChainForHwnd,mCln.m_Device,mCln.m_WindowHandle,addr SwapChainDesc,0,0,addr mCln.m_SwapChain
    .if (eax != 0)
        mov  RetVal, DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@retm
    .endif

    coinvoke mCln.m_Factory, IDXGIFactory2, MakeWindowAssociation, mCln.m_WindowHandle, DXGI_MWA_NO_ALT_ENTER
    .if (eax != 0)
        mov  RetVal, DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@retm
    .endif          

    coinvoke mCln.m_Device, ID3D11Device, CreateTexture2D, addr mCln.m_Deskr, 0, addr mCln.m_SharedSurf    
    .if (eax == 0)
       coinvoke mCln.m_SharedSurf, ID3D11Texture2D, QueryInterface, addr IID_IDXGIKeyedMutex, addr mCln.m_KeyMutex
    .endif
 
    mov       DXGIResource, 0
    coinvoke  mCln.m_SharedSurf, ID3D11Texture2D, QueryInterface, addr IID_IDXGIResource, addr DXGIResource    
    .if ( eax == 0 )        
        coinvoke DXGIResource, IDXGIResource, GetSharedHandle, addr mCln.m_ShareHandle  
        coinvoke DXGIResource, IDXGIResource, Release
    .endif
 
 
    invoke  memset, addr SampDesc, 0, sizeof SampDesc
    mov     SampDesc.Filter, D3D11_FILTER_MIN_MAG_MIP_LINEAR
    mov     SampDesc.AddressU, D3D11_TEXTURE_ADDRESS_CLAMP
    mov     SampDesc.AddressV, D3D11_TEXTURE_ADDRESS_CLAMP
    mov     SampDesc.AddressW,  D3D11_TEXTURE_ADDRESS_CLAMP
    mov     SampDesc.ComparisonFunc,  D3D11_COMPARISON_NEVER
    mov     SampDesc.MinLOD, 0
    fldz
    fstp    SampDesc.MinLOD
    fld     real@7f7fffff
    fstp    SampDesc.MaxLOD
    
    coinvoke  mCln.m_Device, ID3D11Device, CreateSamplerState, addr SampDesc, addr mCln.m_SamplerLinear 
    .if ( eax != 0 )    
        mov  RetVal,  DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@retm
    .endif

    mov      BlendStateDesc.AlphaToCoverageEnable, FALSE
    mov      BlendStateDesc.IndependentBlendEnable, FALSE
    mov      BlendStateDesc.RenderTarget[0].BlendEnable, TRUE
    mov      BlendStateDesc.RenderTarget[0].SrcBlend,  D3D11_BLEND_SRC_ALPHA
    mov      BlendStateDesc.RenderTarget[0].DestBlend, D3D11_BLEND_INV_SRC_ALPHA
    mov      BlendStateDesc.RenderTarget[0].BlendOp,  D3D11_BLEND_OP_ADD
    mov      BlendStateDesc.RenderTarget[0].SrcBlendAlpha,  D3D11_BLEND_ONE
    mov      BlendStateDesc.RenderTarget[0].DestBlendAlpha,  D3D11_BLEND_ZERO
    mov      BlendStateDesc.RenderTarget[0].BlendOpAlpha,  D3D11_BLEND_OP_ADD
    mov      BlendStateDesc.RenderTarget[0].RenderTargetWriteMask,  D3D11_COLOR_WRITE_ENABLE_ALL
    
    coinvoke mCln.m_Device, ID3D11Device, CreateBlendState, addr BlendStateDesc, addr mCln.m_BlendState    
    .if ( eax != 0)    
        mov  RetVal,  DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@retm
    .endif
 
    invoke D3d11WinInitShaders, this_ 
    mov   RetVal, eax
    .if (RetVal != DUPL_RETURN_SUCCESS)            
        jmp @@retm
    .endif
    

    invoke GetWindowRect, mCln.m_WindowHandle, addr WindowRect

    mov    edx, mCln.m_DeskRct.right
    sub    edx, mCln.m_DeskRct.left
    shr    edx, 1
    mov    dWidth, edx    
    mov    ecx, mCln.m_DeskRct.bottom
    sub    ecx, mCln.m_DeskRct.top
    shr    ecx, 1
    mov    dHeight, ecx
    invoke MoveWindow, mCln.m_WindowHandle, WindowRect.left, WindowRect.top, dWidth, dHeight, 1 

@@retm:
    mov   eax, RetVal 
    ret

D3d11ImplementWin endp

;##########################################

D3d11WinInitShaders proc uses esi edi ebx this_:dword  
 
    LOCAL hr : dword 
    
    mov       ebx, this_
    coinvoke  mCln.m_Device, ID3D11Device, CreateVertexShader, addr g_VS_0, 664, 0, addr mCln.m_VertexShader
    mov       hr, eax 

    coinvoke  mCln.m_Device, ID3D11Device, CreateInputLayout, addr Layout, 2, addr g_VS_0, 664, addr mCln.m_InputLayout
    .if ( eax != 0)    
        mov    eax,  DUPL_RETURN_ERROR_UNEXPECTED
        jmp    @@ert
    .endif    
    coinvoke mCln.m_DeviceContext, ID3D11DeviceContext, IASetInputLayout, mCln.m_InputLayout    
    
    coinvoke mCln.m_Device, ID3D11Device, CreatePixelShader, addr g_PS_0, 692, 0,  addr mCln.m_PixelShader
    mov      hr, eax
    mov      eax, DUPL_RETURN_SUCCESS
@@ert:
    ret


D3d11WinInitShaders endp

;##########################################

CreateD3d11WindowObj proc uses esi edi ebx this_:dword 

    LOCAL  DxgiDevice : dword
    LOCAL  DxgiAdapter : dword
    LOCAL  hr : dword
    LOCAL  FeatureLevel : dword
    LOCAL  RetVal : dword
    
    
    mov    ebx, this_
    xor    esi, esi
    .while esi < 3        
       invoke D3D11CreateDevice, 0, DriverTypes[esi*4], 0, 0, addr FeatureLevels, 4, D3D11_SDK_VERSION, addr mCln.m_Device, addr FeatureLevel, addr mCln.m_DeviceContext
       mov    hr, eax
       .if eax == 0                    
          .break
       .endif
       inc  esi
    .endw
    .if (hr != 0)        
        mov  RetVal, DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@retm
    .endif
    
    mov      DxgiDevice, 0
    coinvoke mCln.m_Device,ID3D11Device, QueryInterface, addr IID_IDXGIDevice, addr DxgiDevice
    mov      eax, hr
    .if (hr != 0)    
        mov  RetVal, DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@retm
    .endif

    mov      DxgiAdapter, 0    
    coinvoke DxgiDevice, IDXGIDevice, GetParent, addr IID_IDXGIAdapter, addr DxgiAdapter
    mov      hr, eax
    coinvoke DxgiDevice, IDXGIDevice, Release
    .if (hr != 0)
        mov  RetVal, DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@retm
    .endif

    coinvoke DxgiAdapter, IDXGIAdapter, GetParent, addr IID_IDXGIFactory2, addr mCln.m_Factory
    mov      hr, eax
    coinvoke DxgiAdapter, IDXGIAdapter, Release    
    .if (hr != 0)
        mov  RetVal, DUPL_RETURN_ERROR_UNEXPECTED
        jmp  @@retm
    .endif
    mov    eax, RetVal
@@retm:
    ret

CreateD3d11WindowObj endp 

;##########################################

FreeScreenPlayer2 proc uses esi edi ebx this_:dword

    
    mov   ebx, this_
    .if dword ptr mCln.m_DeviceContext2 != 0
       coinvoke mCln.m_DeviceContext2, IUnknown, Release
       mov      mCln.m_DeviceContext2, 0
    .endif
    .if (dword ptr mCln.m_VertexShader != 0)    
        coinvoke mCln.m_VertexShader,IUnknown,Release          
        mov      mCln.m_VertexShader, 0
    .endif

    .if (dword ptr mCln.m_PixelShader != 0)    
        coinvoke mCln.m_PixelShader,IUnknown,Release
        mov      mCln.m_PixelShader, 0
    .endif

    .if (dword ptr mCln.m_InputLayout != 0)    
        coinvoke mCln.m_InputLayout,IUnknown,Release
        mov      mCln.m_InputLayout, 0
    .endif

    .if (dword ptr mCln.m_RTV != 0)    
        coinvoke mCln.m_RTV,IUnknown,Release
        mov      mCln.m_RTV, 0
    .endif

    .if (dword ptr mCln.m_SamplerLinear != 0)    
        coinvoke mCln.m_SamplerLinear,IUnknown,Release
        mov      mCln.m_SamplerLinear, 0
    .endif

    .if (dword ptr mCln.m_BlendState != 0)    
        coinvoke mCln.m_BlendState,IUnknown,Release
        mov      mCln.m_BlendState, 0
    .endif

    .if (dword ptr mCln.m_DeviceContext != 0)    
        coinvoke mCln.m_DeviceContext,IUnknown,Release
        mov      mCln.m_DeviceContext, 0
    .endif

    .if (dword ptr mCln.m_Device != 0)    
        coinvoke mCln.m_Device,IUnknown,Release
        mov      mCln.m_Device, 0
    .endif

    .if (dword ptr mCln.m_SwapChain != 0)    
        coinvoke mCln.m_SwapChain,IUnknown,Release
        mov      mCln.m_SwapChain, 0 
    .endif

    .if (dword ptr mCln.m_SharedSurf != 0)    
        coinvoke mCln.m_SharedSurf,IUnknown,Release
        mov      mCln.m_SharedSurf, 0
    .endif

    .if (dword ptr mCln.m_KeyMutex != 0)    
        coinvoke mCln.m_KeyMutex,IUnknown,Release
        mov      mCln.m_KeyMutex, 0
    .endif

    .if (dword ptr mCln.m_Factory != 0)    
        .if (dword ptr mCln.m_OcclusionCookie != 0)        
            coinvoke mCln.m_Factory, IDXGIFactory2, UnregisterOcclusionStatus, mCln.m_OcclusionCookie
            mov      mCln.m_OcclusionCookie, 0
        .endif
        coinvoke mCln.m_Factory,IUnknown,Release
        mov      mCln.m_Factory, 0
    .endif
    .if dword ptr  mCln.m_Device2 != 0
       coinvoke mCln.m_Device2, IUnknown, Release
       mov      mCln.m_Device2, 0
    .endif
    invoke CloseHandle, mCln.m_EvntThrStop 
    mov    mCln.m_EvntThrStop, 0
    invoke CloseHandle, mCln.m_evntGo 
    mov    mCln.m_evntGo, 0    
    mov    mCln.m_fFirst, 0
    invoke memset, ebx  , 0, sizeof CLIENT_MANAGER
invoke SendDlgItemMessage, g_hDlg, 203, WM_SETTEXT, 0, 0
invoke GetDlgItem, g_hDlg, 304
invoke EnableWindow, eax, 1   
invoke GetDlgItem, g_hDlg, 305
invoke EnableWindow, eax, 1    
invoke SetDlgItemInt, g_hDlg, 204, 0, 0 
invoke SetDlgItemInt, g_hDlg, 205, 0, 0 
invoke SetDlgItemInt, g_hDlg, 206, 0, 0 
invoke SetDlgItemInt, g_hDlg, 207, 0, 0 
    ret
    
FreeScreenPlayer2 endp

;##########################################

D3d11WinDrawTexture  proc uses esi edi ebx this_:dword, SharedSurf:dword

    LOCAL  ShaderDesc     : D3D11_SHADER_RESOURCE_VIEW_DESC   
    LOCAL  ThisDesc       : D3D11_TEXTURE2D_DESC
    LOCAL  ShaderResource : dword
    LOCAL  VertexBuffer   : dword
    LOCAL  Stride         : dword
    LOCAL  dOffset        : dword
    LOCAL  InitData       : D3D11_SUBRESOURCE_DATA 
    LOCAL  BufferDesc     : D3D11_BUFFER_DESC


    mov      ebx, this_
    .if dword ptr mCln.m_DeviceContext2 == 0
       jmp   @@Ert
    .endif
    coinvoke SharedSurf, ID3D11Texture2D, GetDesc, addr ThisDesc
    
    mov      eax, ThisDesc.Format       ; D3D11_TEXTURE2D_DESC
    mov      ShaderDesc.Format, eax      ; D3D11_SHADER_RESOURCE_VIEW_DESC 
    
    mov      ShaderDesc.ViewDimension, D3D11_SRV_DIMENSION_TEXTURE2D
    
    mov      eax, ThisDesc.MipLevels
    dec      eax
    mov      ShaderDesc.Texture2D.MostDetailedMip, eax
    
    mov      eax, ThisDesc.MipLevels
    mov      ShaderDesc.Texture2D.MipLevels, eax
    
    ; Create a new shader resource view
    mov      ShaderResource, 0
    coinvoke mCln.m_Device, ID3D11Device, CreateShaderResourceView, mCln.m_SharedSurf, addr ShaderDesc, addr ShaderResource    
    .if  eax != 0 
        mov  eax, DUPL_RETURN_SUCCESS
        jmp   @@Ert
    .endif    
    coinvoke mCln.m_DeviceContext,ID3D11DeviceContext, OMSetBlendState, 0, addr blendFactor, 0ffffffffh
    coinvoke mCln.m_DeviceContext,ID3D11DeviceContext, OMSetRenderTargets, 1, addr mCln.m_RTV, 0
    coinvoke mCln.m_DeviceContext,ID3D11DeviceContext, VSSetShader, mCln.m_VertexShader, 0, 0
    coinvoke mCln.m_DeviceContext,ID3D11DeviceContext, PSSetShader, mCln.m_PixelShader, 0, 0          
    coinvoke mCln.m_DeviceContext,ID3D11DeviceContext, PSSetShaderResources,0, 1, addr ShaderResource    
    coinvoke mCln.m_DeviceContext,ID3D11DeviceContext, PSSetSamplers,0, 1, addr mCln.m_SamplerLinear
    coinvoke mCln.m_DeviceContext,ID3D11DeviceContext, IASetPrimitiveTopology, D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST

    
    invoke   memset, addr BufferDesc, 0, sizeof BufferDesc
    mov      BufferDesc.Usage,  D3D11_USAGE_DEFAULT             ; BufferDesc
    mov      BufferDesc.ByteWidth,  sizeof VERTEX * NUMVERTICES
    mov      BufferDesc.BindFlags, D3D11_BIND_VERTEX_BUFFER
    mov      BufferDesc.CPUAccessFlags, 0
   
   
   ; Vertices To Draw The Whole Texture
   
    invoke   memset, addr InitData, 0, sizeof InitData
    lea      eax, Vertices1
    mov      InitData.pSysMem, eax          ; D3D11_SUBRESOURCE_DATA
    
    ; Create a vertex buffer
    mov      Stride, sizeof VERTEX
    mov      VertexBuffer, 0
    coinvoke mCln.m_Device, ID3D11Device, CreateBuffer, addr BufferDesc, addr InitData, addr VertexBuffer    
    .if (eax != 0)    
        coinvoke ShaderResource, ID3D11ShaderResourceView, Release
        mov      eax, DUPL_RETURN_ERROR_UNEXPECTED
        jmp      @@Ert
    .endif
    
    ; Set resources
    coinvoke mCln.m_DeviceContext, ID3D11DeviceContext, IASetVertexBuffers, 0, 1, addr VertexBuffer, addr Stride, addr dOffset  
    
    ; Draw a textured quad on the render target
    coinvoke mCln.m_DeviceContext, ID3D11DeviceContext, Draw, NUMVERTICES, 0
            
    .if VertexBuffer != 0
       coinvoke VertexBuffer, ID3D11DeviceContext, Release  
    .endif
    
    ; Release shader resource
    .if ShaderResource != 0 
       coinvoke ShaderResource, ID3D11ShaderResourceView, Release
    .endif
@@Ert:
    ret    


D3d11WinDrawTexture endp

;#######################################



