
comment *

kfjelrkjerjle

*




.code

;##########################################

D3D11ScreenRecorder proc uses esi edi ebx   this_:dword    

       LOCAL  retVal  : dword
       LOCAL  xsize   : dword
       LOCAL  psiz    : dword
       LOCAL  FrmCntr : dword       
       LOCAL  dwTick  : dword
       LOCAL  ThsIdk1 : dword
       LOCAL  buffrp2[100] : byte
       LOCAL  CurrentDesktop : dword
       LOCAL  DesktopAttached : dword
              
       mov     FrmCntr, 0


       mov    DesktopAttached, 0
       invoke OpenInputDesktop, 0, FALSE, GENERIC_ALL
       mov    CurrentDesktop, eax
       .if (!CurrentDesktop)            
          mov  retVal, DUPL_RETURN_ERROR_EXPECTED
          jmp  @@Err
       .endif
        
       invoke SetThreadDesktop, CurrentDesktop
       .if  eax != 0
          mov    DesktopAttached, 1
       .endif
       invoke CloseDesktop, CurrentDesktop
       .if (!DesktopAttached)            
          mov  retVal, DUPL_RETURN_ERROR_EXPECTED
          jmp  @@Err
       .endif
                
       invoke InitD3D11, addr SrvMng, 0

       lea     esi, SrvMng
       
       invoke  GetTickCount
       mov     dwTick, eax
            
       invoke  OpenMvFile, this_, SrvMng.m_VidSiz
;--             
       invoke GetD3d11Screen, this_, mSrv.m_CurFrame
       .if eax != 0
          mov   retVal, 261
          jmp   @@Err         
       .endif       
       invoke RGBCompressor,this_, mSrv.m_CurFrame, RGB_4bit       
       
       add    mSrv.m_dtPntr, sizeof  VIDEO_FILE_HEADER
            
       invoke AddInMvFile1, this_, mSrv.m_CurFrame 
      
       invoke CreateEvent, 0, 1, 0, 0
       mov    mSrv.m_evntStop, eax

;====================

       .while (1)
          invoke WaitForSingleObjectEx, mSrv.m_evntStop, mSrv.m_Delay, FALSE
          .if eax != WAIT_TIMEOUT
             .break
          .endif
         
          invoke GetD3d11Screen, this_, mSrv.m_NewFrame
          .if eax == DXGI_ERROR_WAIT_TIMEOUT
             .continue
          .endif
          .if eax != 0
             mov   retVal, 261
             jmp   @@Err          
          .endif  

          invoke RGBCompressor, this_, mSrv.m_NewFrame, RGB_4bit            
          invoke UpdateMainFrame, this_, mSrv.m_CurFrame, mSrv.m_NewFrame, mSrv.m_DifFrame
                                         
          invoke AddInMvFile, this_, mSrv.m_DifFrame       

          inc   FrmCntr
       .endw       

;=====================
;       mov    mSrv.m_FlFirst, 2
;       invoke SetEvent, mSrv.m_evntNext
;-      
       invoke  GetTickCount       
       sub     eax, dwTick
       
       mov     edi, mSrv.m_pMem
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwTime, eax
       mov     ecx, "ONIK"
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwSign, ecx
       mov     eax, mSrv.m_Widh
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwWidh, eax
       mov     eax, mSrv.m_Hight
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwHeig, eax
       mov     eax, mSrv.m_Delay
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwFps, eax
       mov     eax, FrmCntr
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwFrCn, eax
       mov     eax, mSrv.m_dtPntr
       sub     eax, mSrv.m_pMem
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwSize, eax
;                                   
       mov     eax, (VIDEO_FILE_HEADER ptr [edi]).dwTime
       xor     edx, edx
       mov     ecx, 1000
       div     ecx  
       mov     edx, (VIDEO_FILE_HEADER ptr [edi]).dwSize
       shr     edx, 10
       invoke  wsprintfA, addr buffrp2, addr sztem33, eax, FrmCntr, edx            
       invoke  MessageBox, 0, addr buffrp2, addr szRerror, 0
       
       invoke  CloseMvFile, this_         
@@Fin:
       
       invoke SrvClean, esi
       mov    g_type, 0
       ret
@@Err:
       invoke GetLastError
       .if    eax == 0
          
       .endif

       jmp    @@Fin

     
D3D11ScreenRecorder endp

;###########################################################

InitD3D11 proc uses esi edi ebx this_:dword, lSingleOutput:dword
        

    LOCAL  DesktopDesc       : DXGI_OUTPUT_DESC     
    LOCAL  hr                : dword 
    LOCAL  pDxgiAdapter      : dword ; IDXGIAdapter
    LOCAL  pDxgiDevice       : dword ; IDXGIDevice
    LOCAL  pDxgiOutput       : dword ; IDXGIOutput
    LOCAL  pDxgiOutput1      : dword ; IDXGIOutput1
    LOCAL  FeatureLevel      : dword         
    LOCAL  RetVal            : dword 
    LOCAL  lOutputDuplDesc   : DXGI_OUTDUPL_DESC 
    LOCAL  desc              : D3D11_TEXTURE2D_DESC
    
    mov    esi, this_
   ; invoke memset, esi, 0, sizeof SERVER_MANAGER
    mov    RetVal, 0
    xor    ebx, ebx
    .while ebx < 3        
       invoke D3D11CreateDevice, 0, DriverTypes[ebx*4], 0, 0, addr FeatureLevels, 4, D3D11_SDK_VERSION, addr mSrv.m_Device, addr FeatureLevel, addr mSrv.m_DeviceContext
       .if eax == 0                    
         .break
       .endif
       inc  ebx
    .endw
    .if eax != 0    
       mov  RetVal, eax
       jmp  @@efrt 
    .endif
    
    invoke   srMemManagerInit, esi    
;    invoke   CreateEvent, 0,0,0,0
;    mov      mSrv.m_evntNext, eax
           
    mov      pDxgiDevice, 0
    coinvoke mSrv.m_Device, ID3D11Device, QueryInterface, addr IID_IDXGIDevice, addr pDxgiDevice    
    .if eax != 0
       mov  RetVal, eax
       jmp  @@efrt 
    .endif
        
    mov      pDxgiAdapter, 0
    coinvoke pDxgiDevice, IDXGIDevice, GetParent, addr IID_IDXGIAdapter, addr pDxgiAdapter    
    .if eax != 0
       mov  RetVal, eax
       jmp  @@efrt 
    .endif    
    coinvoke pDxgiDevice, IDXGIDevice, Release
   
    coinvoke pDxgiAdapter, IDXGIAdapter, EnumOutputs, lSingleOutput, addr pDxgiOutput    
    .if (eax != 0)        
       coinvoke pDxgiAdapter, IDXGIAdapter, Release        
       mov      eax, DUPL_RETURN_ERROR_UNEXPECTED
       jmp      @@efrt
    .endif                
    coinvoke pDxgiAdapter, IDXGIAdapter, Release   

    coinvoke pDxgiOutput, IDXGIOutput, GetDesc, addr DesktopDesc

    mov      pDxgiOutput1, 0
		coinvoke pDxgiOutput, IDXGIOutput, QueryInterface, addr IID_IDXGIOutput1, addr pDxgiOutput1		
		.if eax != 0
		    mov RetVal, 244
		    jmp  @@efrt
		.endif
		coinvoke pDxgiOutput, IDXGIOutput, Release		

		mov      mSrv.m_DeskDupl, 0
		coinvoke pDxgiOutput1, IDXGIOutput1, DuplicateOutput, mSrv.m_Device, addr mSrv.m_DeskDupl
		.if eax != 0
		    mov RetVal, 252
		    jmp  @@efrt
		.endif
		coinvoke pDxgiOutput1, IDXGIOutput1, Release	
            
		coinvoke mSrv.m_DeskDupl, IDXGIOutputDuplication, GetDesc, addr lOutputDuplDesc

 	  mov      eax, lOutputDuplDesc.ModeDesc.dWidth
		mov      desc.dWidth, eax
    mov      eax, lOutputDuplDesc.ModeDesc.dHeight
		mov      desc.dHeight, eax
    mov      eax, lOutputDuplDesc.ModeDesc.Format
		mov      desc.Format, eax
		mov      desc.ArraySize, 1
		mov      desc.MipLevels, 1
		mov      desc.SampleDesc.Count, 1
		mov      desc.SampleDesc.Quality, 0
		mov      desc.BindFlags, D3D11_BIND_RENDER_TARGET
		mov      desc.MiscFlags, D3D11_RESOURCE_MISC_GDI_COMPATIBLE
		mov      desc.CPUAccessFlags, 0
		mov      desc.Usage, D3D11_USAGE_DEFAULT		 		 
		coinvoke mSrv.m_Device, ID3D11Device, CreateTexture2D, addr desc, 0, addr mSrv.m_GDIImage
    .if eax != 0
       mov RetVal, 114
       jmp  @@efrt
    .endif 	
		
		mov      eax, lOutputDuplDesc.ModeDesc.dWidth
		mov      desc.dWidth, eax
		mov      eax, lOutputDuplDesc.ModeDesc.dHeight
		mov      desc.dHeight, eax
		mov      eax, lOutputDuplDesc.ModeDesc.Format
		mov      desc.Format, eax
		mov      desc.ArraySize, 1
		mov      desc.MipLevels, 1
		mov      desc.SampleDesc.Count, 1
		mov      desc.SampleDesc.Quality, 0
		mov      desc.BindFlags, 0
		mov      desc.MiscFlags, 0
		mov      desc.CPUAccessFlags, D3D11_CPU_ACCESS_READ or D3D11_CPU_ACCESS_WRITE
		mov      desc.Usage, D3D11_USAGE_STAGING     
    mov      mSrv.m_DestImage, 0
		coinvoke mSrv.m_Device, ID3D11Device, CreateTexture2D, addr desc, 0, addr mSrv.m_DestImage
    .if eax != 0
       mov RetVal, 135
       jmp  @@efrt
    .endif 	
     
    mov      desc.Format, DXGI_FORMAT_B8G8R8A8_UNORM         
    mov      desc.Usage, D3D11_USAGE_DEFAULT        
    mov      desc.CPUAccessFlags, 0    
    mov      desc.BindFlags, D3D11_BIND_RENDER_TARGET or D3D11_BIND_SHADER_RESOURCE
    mov      desc.MiscFlags, D3D11_RESOURCE_MISC_SHARED_KEYEDMUTEX  
    invoke   memcpy,addr mSrv.m_TextDesc, addr desc, sizeof D3D11_TEXTURE2D_DESC

    mov      eax, lOutputDuplDesc.ModeDesc.dHeight
    mov      mSrv.m_Hight, eax     
     
    mov      eax, lOutputDuplDesc.ModeDesc.dWidth
    mov      mSrv.m_Widh, eax
                  
    mov      eax, mSrv.m_Hight
    mov      ecx, mSrv.m_Widh
    mul      ecx
    shl      eax, 2
    mov      mSrv.m_Size, eax          

@@efrt:
    ret

InitD3D11 endp

;##########################################

GetD3d11Screen proc uses esi edi ebx  this_:dword, pBuff:dword

     
     LOCAL  lAcquiredDesktopImage : dword ; ID3D11Texture2D     
     LOCAL  resource              : D3D11_MAPPED_SUBRESOURCE   
     LOCAL  lFrameInfo            : DXGI_OUTDUPL_FRAME_INFO    
     LOCAL  lDesktopResource      : dword ; IDXGIResource
         
     LOCAL  lTryCount             : dword
     LOCAL  subresource           : dword    
     LOCAL  RetVal                : dword      
	 		
	 		
	 	 mov   	esi, this_
	 	 mov    RetVal, 0
	 	 mov    lAcquiredDesktopImage, 0

          
     mov    lTryCount, 4
		 mov    lDesktopResource, 0
		 .while lTryCount != 0
		    invoke   Sleep, 100			
			  coinvoke mSrv.m_DeskDupl, IDXGIOutputDuplication, AcquireNextFrame, 250, addr lFrameInfo, addr lDesktopResource			
			  .if (eax == 0)
				   .break
        .endif			
			  .if (eax == DXGI_ERROR_WAIT_TIMEOUT)			
				   .continue			
			  .elseif (eax != 0)
				   .break			
        .endif
        dec  lTryCount
     .endw   

		 .if 	lDesktopResource == 0
   			mov RetVal, 200
			  jmp  @@fin	 
		 .endif		 

		 mov      lAcquiredDesktopImage, 0
		 coinvoke lDesktopResource, IDXGIResource, QueryInterface, addr IID_ID3D11Texture2D, addr lAcquiredDesktopImage
		 .if eax != 0
   			mov RetVal, 208
			  jmp  @@fin			    
		 .endif
		 coinvoke lDesktopResource, IDXGIResource, Release					

		  ; Copy image into GDI drawing texture

		 coinvoke mSrv.m_DeviceContext, ID3D11DeviceContext, CopyResource, mSrv.m_GDIImage, lAcquiredDesktopImage

		; Copy image into CPU access texture

		 coinvoke mSrv.m_DeviceContext, ID3D11DeviceContext, CopyResource, mSrv.m_DestImage, mSrv.m_GDIImage

		; Copy from CPU access texture to bitmap buffer

		 coinvoke mSrv.m_DeviceContext, ID3D11DeviceContext, Map, mSrv.m_DestImage, 0, D3D11_MAP_READ_WRITE, 0, addr resource
     .if eax != 0
        mov RetVal, 226
			  jmp  @@fin			
		 .endif	 
     
     invoke   memcpy, pBuff, resource.pData, resource.DepthPitch
     
     coinvoke mSrv.m_DeviceContext, ID3D11DeviceContext, Unmap, mSrv.m_DestImage, 0 
     coinvoke mSrv.m_DeskDupl, IDXGIOutputDuplication, ReleaseFrame
    
@@fin:   
     .if lAcquiredDesktopImage != 0 
        coinvoke lAcquiredDesktopImage, IUnknown, Release	              
     .endif     
          
     mov   eax, RetVal
     .if eax != 0     
;        PrintHex eax, "GetD3d11Screen return"	
     .endif
     ret

    
GetD3d11Screen endp    

;#######################################

SrvClean proc uses esi edi ebx this_:dword

     mov      esi, this_     
     coinvoke mSrv.m_DeskDupl, IUnknown, Release	
     coinvoke mSrv.m_DestImage, IUnknown, Release	
     coinvoke mSrv.m_GDIImage, IUnknown, Release	 
     coinvoke mSrv.m_DeviceContext, IDXGIOutput, Release	  
     coinvoke mSrv.m_Device, IDXGIOutput, Release	
;     invoke   CloseHandle, mSrv.m_evntNext
     invoke   CloseHandle, mSrv.m_evntStop
     invoke   srMemManagerFree, esi
     ret


SrvClean endp

;#######################################

