




.code

;#############################################

GDIScreenRecorder proc uses esi edi ebx  this_:dword    

       LOCAL  retVal  : dword
       LOCAL  xsize   : dword
       LOCAL  psiz    : dword
       LOCAL  FrmCntr : dword       
       LOCAL  dwTick  : dword
       LOCAL  ThsIdk1 : dword
       LOCAL  buffrp2[100] : byte
       LOCAL  CurrentDesktop : dword
       LOCAL  DesktopAttached : dword
              
       mov     FrmCntr, 0

       mov    DesktopAttached, 0
       invoke OpenInputDesktop, 0, FALSE, GENERIC_ALL
       mov    CurrentDesktop, eax
       .if (!CurrentDesktop)            
          mov  retVal, DUPL_RETURN_ERROR_EXPECTED
          jmp  @@Err
       .endif
        
       invoke SetThreadDesktop, CurrentDesktop
       .if  eax != 0
          mov    DesktopAttached, 1
       .endif
       invoke CloseDesktop, CurrentDesktop
       .if (!DesktopAttached)            
          mov  retVal, DUPL_RETURN_ERROR_EXPECTED
          jmp  @@Err
       .endif
                       
       lea     esi, SrvMng
       
       invoke GDIInit, addr SrvMng

       
       invoke  GetTickCount
       mov     dwTick, eax
            
       invoke  OpenMvFile, this_, SrvMng.m_VidSiz
;--             
       invoke GetGDIScreen, this_, mSrv.m_CurFrame
       .if eax != 0
          mov   retVal, 261
          jmp   @@Err         
       .endif       
       invoke RGBCompressor,this_, mSrv.m_CurFrame, RGB_4bit       
       
       add    mSrv.m_dtPntr, sizeof  VIDEO_FILE_HEADER
            
       invoke AddInMvFile1, this_, mSrv.m_CurFrame 
      
       invoke CreateEvent, 0, 1, 0, 0
       mov    mSrv.m_evntStop, eax

;====================

       .while (1)
          invoke WaitForSingleObjectEx, mSrv.m_evntStop, mSrv.m_Delay, FALSE
          .if eax != WAIT_TIMEOUT
             .break
          .endif
         
          invoke GetGDIScreen, this_, mSrv.m_NewFrame
          .if eax == DXGI_ERROR_WAIT_TIMEOUT
             .continue
          .endif
          .if eax != 0
             mov   retVal, 261
             jmp   @@Err          
          .endif  

          invoke RGBCompressor, this_, mSrv.m_NewFrame, RGB_4bit            
          invoke UpdateMainFrame, this_, mSrv.m_CurFrame, mSrv.m_NewFrame, mSrv.m_DifFrame
                                         
          invoke AddInMvFile, this_, mSrv.m_DifFrame       

          inc   FrmCntr
       .endw       

;=====================
;       mov    mSrv.m_FlFirst, 2
;       invoke SetEvent, mSrv.m_evntNext
;-      
       invoke  GetTickCount       
       sub     eax, dwTick
       
       mov     edi, mSrv.m_pMem
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwTime, eax
       mov     ecx, "ONIK"
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwSign, ecx
       mov     eax, mSrv.m_Widh
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwWidh, eax
       mov     eax, mSrv.m_Hight
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwHeig, eax
       mov     eax, mSrv.m_Delay
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwFps, eax
       mov     eax, FrmCntr
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwFrCn, eax
       mov     eax, mSrv.m_dtPntr
       sub     eax, mSrv.m_pMem
       mov     (VIDEO_FILE_HEADER ptr [edi]).dwSize, eax
;                                   
       mov     eax, (VIDEO_FILE_HEADER ptr [edi]).dwTime
       xor     edx, edx
       mov     ecx, 1000
       div     ecx  
       mov     edx, (VIDEO_FILE_HEADER ptr [edi]).dwSize
       shr     edx, 10
       invoke  wsprintfA, addr buffrp2, addr sztem33, eax, FrmCntr, edx            
       invoke  MessageBox, 0, addr buffrp2, addr szRerror, 0
       
       invoke  CloseMvFile, this_         
@@Fin:
       
       invoke GDIClean, esi
       mov    g_type, 0
       ret
@@Err:
       invoke GetLastError
       .if    eax == 0
          
       .endif

       jmp    @@Fin

     
GDIScreenRecorder endp

;#############################################

GDIInit proc uses esi edi ebx this_:dword
 
      LOCAL  Dishdc : dword

      mov     esi, this_
      invoke  GetDC, 0
      mov     Dishdc, eax                                                                                      

      invoke  CreateCompatibleDC, Dishdc                                  
      mov     SrvMng.m_cphDisp, eax             
                                                 
      invoke  GetSystemMetrics, SM_CXSCREEN  
      mov     SrvMng.m_Widh, eax         

      invoke  GetSystemMetrics, SM_CYSCREEN
      mov     SrvMng.m_Hight, eax                 
      mov     ecx, SrvMng.m_Widh
      mul     ecx
      shl     eax, 2
      mov     SrvMng.m_Size, eax        
              
      invoke  CreateCompatibleBitmap, Dishdc, SrvMng.m_Widh, SrvMng.m_Hight
      mov     SrvMng.m_hlBmp, eax                              

      invoke  SelectObject, SrvMng.m_cphDisp, SrvMng.m_hlBmp
      mov     SrvMng.m_oldbmp, eax  
      
      invoke  DeleteDC, Dishdc  

          
       
      invoke  srMemManagerInit, esi          
;      invoke  CreateEvent, 0,0,0,0
;      mov     mSrv.m_evntNext, eax      
      ret


GDIInit endp

;#############################################

GetGDIScreen proc uses esi ebx edi this_:dword, pMem:dword

      LOCAL   Dishdc     : dword
      LOCAL   cphDisp    : dword
      LOCAL   hlBmp      : dword
      LOCAL   DispWidh   : dword
      LOCAL   DispHeight : dword
      LOCAL   lpBits     : dword  
      LOCAL   oldbmp     : dword
      LOCAL   lMem       : dword
      LOCAL   slMem      : dword
      LOCAL   kpData     : dword
      LOCAL   lcntr      : dword
      LOCAL   LopStep    : dword
      LOCAL   bminfo     : BITMAPINFO
             
      
      mov     esi, this_
      invoke  memset, addr  bminfo, 0, sizeof  BITMAPINFO  

      invoke  GetDC, 0
      mov     Dishdc, eax                                                                                      
                                                                                                                                         
      invoke  GdiFlush     
                                
      mov     eax, SrvMng.m_Widh
      mov     bminfo.bmiHeader.biWidth, eax        
                                                   
      mov     eax, SrvMng.m_Hight
      neg     eax
      mov     bminfo.bmiHeader.biHeight, eax                                                                                                                                                   
      mov     bminfo.bmiHeader.biCompression, BI_RGB  
      mov     bminfo.bmiHeader.biSize, sizeof BITMAPINFOHEADER 
      mov     bminfo.bmiHeader.biPlanes, 1                                                                                                                                                              
      mov     bminfo.bmiHeader.biBitCount, 32

      invoke  BitBlt, SrvMng.m_cphDisp, 0, 0, SrvMng.m_Widh, SrvMng.m_Hight, Dishdc, 0, 0, SRCCOPY or 40000000h     ; 0C0CC0020h                                                                                              
                                                                                                                                                    
      invoke  GetDIBits, SrvMng.m_cphDisp, SrvMng.m_hlBmp, 0, SrvMng.m_Hight, pMem, addr bminfo, DIB_RGB_COLORS  

      invoke  DeleteDC, Dishdc                              
      xor     eax, eax
      ret
                
GetGDIScreen endp 

;#############################################

GDIClean proc uses esi edi ebx this_:dword

      mov    esi, this_

      invoke  SelectObject, SrvMng.m_cphDisp, SrvMng.m_oldbmp
      invoke  DeleteObject, SrvMng.m_hlBmp 
      invoke  DeleteDC, SrvMng.m_cphDisp
      invoke  srMemManagerFree, esi
      invoke  CloseHandle, SrvMng.m_evntStop 
      
      ret
                
GDIClean endp 

;#############################################



