


.code

;####################################################

clMemManagerInit proc uses esi edi ebx this_:dword

       LOCAL  hMapr : dword
       
       mov     ebx, this_
       invoke  CreateFileMapping, -1, 0, PAGE_READWRITE, 0, 3840*2160*4 *4, 0
       .if eax == 0
          invoke GetLastError             
          jmp    @@Fin        
       .endif
       mov     clg_hMapr, eax       
       invoke  MapViewOfFile, clg_hMapr, FILE_MAP_WRITE, 0, 0, 0          
       mov     edi, eax             
       mov     mCln.m_CurFrame, edi
       add     edi, 3840*2160*4
       mov     mCln.m_DifFrame, edi
       add     edi, 3840*2160*4
       mov     mCln.m_ZlibBuf, edi
@@Fin :       
       ret 

clMemManagerInit endp

;####################################################

clMemManagerFree proc uses esi edi ebx this_:dword

       mov    ebx, this_       
       invoke UnmapViewOfFile, mCln.m_CurFrame
       invoke CloseHandle, clg_hMapr 
       ret

clMemManagerFree endp

;#############################################


srMemManagerFree proc uses esi edi ebx this_:dword

       mov    esi, this_       
       invoke UnmapViewOfFile, mSrv.m_CurFrame
       invoke CloseHandle, srg_hMapr
       ret

srMemManagerFree endp

;#############################################

srMemManagerInit proc uses esi edi ebx this_:dword

       LOCAL  hMapr : dword
       
       mov     esi, this_
       invoke  CreateFileMapping, -1, 0, PAGE_READWRITE, 0, 3840*2160*4 *4, 0
       .if eax == 0
          invoke GetLastError             
          jmp    @@Fin        
       .endif
       mov     srg_hMapr, eax       
       invoke  MapViewOfFile, srg_hMapr, FILE_MAP_WRITE, 0, 0, 0          
       mov     edi, eax             
       mov     mSrv.m_CurFrame, edi
       add     edi, 3840*2160*4
       mov     mSrv.m_NewFrame, edi
       add     edi, 3840*2160*4
       mov     mSrv.m_DifFrame, edi
       add     edi, 3840*2160*4
       mov     mSrv.m_ZlibBuf, edi
@@Fin :       
       ret 

srMemManagerInit endp

;#############################################