

.code

;######################################################################

ClnCloseVidFile proc uses esi edi ebx this_:dword

           mov    ebx, this_
           invoke UnmapViewOfFile, mCln.m_pMem
           invoke CloseHandle, mCln.m_hMapping              
           invoke CloseHandle, mCln.m_hFile
           invoke clMemManagerFree, ebx

           invoke CloseHandle, mCln.m_evntGo           

           .if dword ptr  mCln.m_hbmp != 0
              invoke  DeleteObject, mCln.m_hbmp
              mov     mCln.m_hbmp, 0
           .endif           

           .if dword ptr mCln.m_cpHdc != 0
              invoke  DeleteDC, mCln.m_cpHdc 
              mov     mCln.m_cpHdc, 0
           .endif                                        
           ret

ClnCloseVidFile endp

;######################################################################

ClnOpenVidFile proc uses esi edi ebx this_:dword


           LOCAL RetVal : dword
           
           mov     RetVal, 0
           mov     ebx, this_                                                                                               
           invoke  CreateFileA, addr mCln.m_FileName, GENERIC_READ OR GENERIC_WRITE, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,0
           .if eax == -1                
              jmp @@Error             
           .endif
           mov     mCln.m_hFile, eax   
           invoke  CreateFileMapping, mCln.m_hFile, 0, PAGE_READWRITE, 0, 0, 0
           .if eax == 0
              jmp  @@Error           
           .endif
           mov     mCln.m_hMapping, eax         
           invoke  MapViewOfFile, mCln.m_hMapping, FILE_MAP_READ, 0, 0, 0                     
           .if eax == 0
              jmp  @@Error              
           .endif
;--
           mov    esi, eax
           add    eax, sizeof VIDEO_FILE_HEADER
           mov    mCln.m_pMem, eax
           mov    mCln.m_dtPntr, eax
;----
           mov    edi, eax
           sub    edi, sizeof VIDEO_FILE_HEADER
           mov    eax, (VIDEO_FILE_HEADER ptr [edi]).dwFrCn
           invoke SetDlgItemInt, g_hDlg, 206, eax, 0            
           mov    eax, (VIDEO_FILE_HEADER ptr [edi]).dwTime
           mov    ecx, 1000
           xor    edx, edx
           div    ecx  
           invoke SetDlgItemInt, g_hDlg, 207, eax, 0  
           mov    eax, (VIDEO_FILE_HEADER ptr [edi]).dwFps
           invoke SetDlgItemInt, g_hDlg, 205, eax, 0  
           invoke GetFileSize, mCln.m_hFile, 0
           shr    eax, 20
           invoke SetDlgItemInt, g_hDlg, 204, eax, 0 
;-------
           invoke memcpy, addr mCln.m_VidInfo, esi, sizeof VIDEO_FILE_HEADER

           mov    eax, mCln.m_VidInfo.dwWidh
           mov    mCln.m_Widh, eax

           mov    ecx, mCln.m_VidInfo.dwHeig           
           mov    mCln.m_Hight, ecx

           mul    ecx
           shl    eax, 2
           mov    mCln.m_Size, eax
@@fin:           
           mov    eax, RetVal
           ret
@@Error:
           invoke GetLastError              
           mov    RetVal, eax
           jmp   @@fin

ClnOpenVidFile endp

;######################################################################

ClnLoadCurrFrame proc  uses edi esi ebx this_:dword 

           LOCAL   pOutSiz  :  dword 

           mov     ebx, this_
           mov     esi, mCln.m_pMem 
           mov     edi, (NET_COMPRES_HEADER ptr [esi]).PackSize                                                             
           add     esi, sizeof NET_COMPRES_HEADER
           mov     pOutSiz, 3840*2160*4 
           invoke  uncompress, mCln.m_CurFrame, addr pOutSiz, esi, edi             
           add     mCln.m_dtPntr, edi
           add     mCln.m_dtPntr, sizeof NET_COMPRES_HEADER
           ret

ClnLoadCurrFrame endp

;######################################################################

ClntLoadNextFrame proc uses esi edi ebx this_:dword
                      
           LOCAL   pOutSiz : dword
           
           mov     ebx, this_
           mov     esi, mCln.m_dtPntr
           mov     edx, mCln.m_pMem
           add     edx, mCln.m_VidInfo.dwSize
           .if esi >= edx
              mov     eax, -1
           .else
              mov     edi, (NET_COMPRES_HEADER ptr [esi]).PackSize                                        
              add     esi, sizeof NET_COMPRES_HEADER
              mov     pOutSiz, 3840*2160*4 
              invoke  uncompress, mCln.m_ZlibBuf, addr pOutSiz, esi, edi             
              invoke  RestoreCurrentFrame, mCln.m_CurFrame, mCln.m_ZlibBuf              
              mov     ecx, sizeof NET_COMPRES_HEADER
              add     ecx, edi
              add     mCln.m_dtPntr, ecx
              xor     eax, eax
           .endif
           ret        

ClntLoadNextFrame endp

;######################################################################
