


.code

;#################################################

PixelConwert proc uses esi edi ebx pBud:dword, dipd:dword


      .if dipd == 3
        lea   ebx, clortbl3
      .elseif dipd == 4
         lea   ebx, clortbl4
      .elseif  dipd == 5
        lea   ebx, clortbl5
      .elseif  dipd == 6
        lea   ebx, clortbl6      
      .elseif  dipd == 7
        lea   ebx, clortbl7
      .elseif  dipd == 8
        lea   ebx, clortbl8            
      .else
        lea   ebx, clortbl3
      .endif      
      mov   esi, pBud
      movzx eax, byte ptr [esi]
      movzx ecx, byte ptr [ebx+eax]
      mov   [esi], cl

      movzx eax, byte ptr [esi+1]
      movzx ecx, byte ptr [ebx+eax]
      mov   [esi+1], cl

      movzx eax, byte ptr [esi+2]
      movzx ecx, byte ptr [ebx+eax]
      mov   [esi+2], cl

      ret

PixelConwert endp

;#######################################

UpdateMainFrame proc uses esi edi ebx this_:dword, pMainFrame:dword, pNewFrame:dword, pOutIdx:dword

       LOCAL   dwContr    : dword  
       LOCAL   lpIdex     : dword
       LOCAL   wrkBuf[80] : byte
       LOCAL   pOutDiff : dword
                                                
       mov     esi, this_
       
       mov     eax, mSrv.m_Size   ;dwSize
       xor     edx, edx
       mov     ecx, 64
       div     ecx                 
       mov     dwContr, eax
       
       mov     edi, pOutIdx    
       mov     lpIdex, edi
       add     lpIdex, sizeof DIFF_FRAME

       mov    eax, mSrv.m_Size
       mov    ecx, 4*8
       xor    edx, edx
       div    ecx                 
       mov    (DIFF_FRAME ptr [edi]).idxSiz, eax

       mov    edx, mSrv.m_Size
       mov    (DIFF_FRAME ptr [edi]).dataSiz, edx

       add    edi, eax
       add    edi, sizeof DIFF_FRAME

       mov    pOutDiff, edi
       
       invoke  memset, pOutDiff, 0, mSrv.m_Size

       mov     edi, pNewFrame
       mov     esi, pMainFrame        

       mov     edx, pOutDiff

       .while ( dwContr != 0 )                          
          xor ebx,ebx
          mov   eax, [edi]
          .if eax != [esi]
             mov  [edx], eax
             btc   ebx, 0  
          .endif  
          mov   eax, [edi+4]
          .if eax != [esi+4]
             mov  [edx+4], eax
             btc   ebx, 1
          .endif           
          mov   eax, [edi+8]
          .if eax != [esi+8]
             mov  [edx+8], eax
             btc   ebx, 2 
          .endif            
          mov   eax, [edi+12]
          .if eax != [esi+12]
             mov  [edx+12], eax
             btc   ebx, 3 
          .endif           
          mov   eax, [edi+16]
          .if eax != [esi+16]
             mov  [edx+16], eax
            btc   ebx, 4 
          .endif 
          mov   eax, [edi+20]
          .if eax != [esi+20]
             mov  [edx+20], eax
             btc   ebx, 5 
          .endif           
          mov   eax, [edi+24]
          .if eax != [esi+24]
             mov  [edx+24], eax
             btc   ebx, 6 
          .endif  
          mov   eax, [edi+28]
          .if eax != [esi+28]
             mov  [edx+28], eax
             btc   ebx, 7 
          .endif           
          mov   eax, [edi+32]
          .if eax != [esi+32]
             mov  [edx+32], eax
             btc   ebx, 8 
          .endif                   
          mov   eax, [edi+36]
          .if eax != [esi+36]
             mov  [edx+36], eax
             btc   ebx, 9 
          .endif           
          mov   eax, [edi+40]
          .if eax != [esi+40]
             mov  [edx+40], eax
             btc   ebx, 10 
          .endif                      
          mov   eax, [edi+44]
          .if eax != [esi+44]
             mov  [edx+44], eax
             btc   ebx, 11 
          .endif           
          mov   eax, [edi+48]
          .if eax != [esi+48]
             mov  [edx+48], eax
             btc   ebx, 12 
          .endif                      
          mov   eax, [edi+52]
          .if eax != [esi+52]
             mov  [edx+52], eax
             btc   ebx, 13 
          .endif           
          mov   eax, [edi+56]
          .if eax != [esi+56]
             mov  [edx+56], eax
             btc   ebx, 14 
          .endif                      
          mov   eax, [edi+60]
          .if eax != [esi+60]
             mov  [edx+60], eax
             btc   ebx, 15 
          .endif            
          mov    eax, lpIdex
          mov    [eax], bx
          inc    lpIdex
          inc    lpIdex                                                                                          
          push   edx          
          invoke memcpy, esi, edi, 64         
          pop    edx                                                                                                                         
          add    edi, 64
          add    esi, 64             
          add    edx, 64    
          dec    dwContr
        .endw

        ret 
                                    
UpdateMainFrame endp   

;#######################################

RestoreCurrentFrame proc uses esi edi ebx lpOldFrm:dword, lpDifFrm:dword            

             
         LOCAL dwContr : dword

         mov   esi, lpDifFrm

         mov   eax, (DIFF_FRAME ptr [esi]).dataSiz     
         mov   ecx, (DIFF_FRAME ptr [esi]).idxSiz                        
         mov   edi, lpOldFrm 

         add   esi, sizeof DIFF_FRAME   ; pixel data

         mov   ebx, esi    
         add   esi, ecx   ; index data            
         xor   edx, edx
         mov   ecx, 64
         div   ecx                 
         mov   dwContr, eax
            
         .while (dwContr != 0)
            movzx    eax, word ptr [ebx]  
            btc  ax, 0            
            jnc  @f               
            mov  ecx, [esi]
            mov  [edi], ecx           
@@:                        
            btc  ax, 1
            jnc  @f
            mov  ecx, [esi+4]
            mov  [edi+4], ecx
@@:                        
            btc  ax, 2
            jnc  @f
            mov  ecx, [esi+8]
            mov  [edi+8], ecx
@@:                        
            btc  ax, 3
            jnc  @f
            mov  ecx, [esi+12]
            mov  [edi+12], ecx
@@:            
            btc  ax, 4
            jnc  @f
            mov  ecx, [esi+16]
            mov  [edi+16], ecx
@@:            
            btc  ax, 5
            jnc  @f
            mov  ecx, [esi+20]
            mov  [edi+20], ecx
@@:            
            btc  ax, 6
            jnc  @f
            mov  ecx, [esi+24]
            mov  [edi+24], ecx
@@:            
            btc  ax, 7
            jnc  @f
            mov  ecx, [esi+28]
            mov  [edi+28], ecx
@@:            
            btc  ax, 8
            jnc  @f
            mov  ecx, [esi+32]
            mov  [edi+32], ecx
@@:            
            btc  ax, 9
            jnc  @f
            mov  ecx, [esi+36]
            mov  [edi+36], ecx
@@:            
            btc  ax, 10
            jnc  @f
            mov  ecx, [esi+40]
            mov  [edi+40], ecx
@@:            
            btc  ax, 11
            jnc  @f
            mov  ecx, [esi+44]
            mov  [edi+44], ecx
@@:            
            btc  ax, 12
            jnc  @f
            mov  ecx, [esi+48]
            mov  [edi+48], ecx
@@:            
            btc  ax, 13
            jnc  @f
            mov  ecx, [esi+52]
            mov  [edi+52], ecx
@@:            
            btc  ax, 14
            jnc  @f
            mov  ecx, [esi+56]
            mov  [edi+56], ecx
@@:            
            btc  ax, 15
            jnc  @f
            mov  ecx, [esi+60]
            mov  [edi+60], ecx
@@:            

            add      edi, 64
            add      esi, 64
            add      ebx, 2                             
            dec      dwContr
         .endw            
            
         ret
            
           
RestoreCurrentFrame endp     

;#################################################

RGBCompressor proc uses esi edi ebx this_:dword, pBuf:dword, dwLevel:dword

    mov  esi, this_ 
    mov  ebx, mSrv.m_Size
    mov  edi, pBuf
    .while ebx != 0           
       invoke PixelConwert, edi, dwLevel
       add    edi, 4
       sub    ebx, 4
     .endw     
     ret

RGBCompressor endp

;#################################################
