

.code

;#############################################

WriteFileDisk proc  uses edi esi ebx lpFeileName:dword, pBuffer:dword, dwSiv:dword                                     

      LOCAL  retVal   : dword
      LOCAL  hzObject : dword
                               
      pushad
      mov     retVal, -1
      invoke  CreateFileA, lpFeileName, 40000000h, 3, 0, 4, 80h, 0
      .if eax != -1                                  
         mov     hzObject, eax  
         invoke  SetFilePointer, hzObject, 0, 0, FILE_END
         invoke  WriteFile, hzObject, pBuffer, dwSiv, esp, 0
         invoke  CloseHandle, hzObject
         mov     retVal, 0
      .endif                                
      popad                 
      mov  eax, retVal
      ret

WriteFileDisk endp

;#############################################

ReadArray proc uses edi esi ebx lpFileName:dword, pOutMem:dword, pOutSiz:dword
                                    

    LOCAL  nNumberOfBytesToRead : dword
    LOCAL  hObject : dword
                    
    mov     ebx, 0FFFFFFFFh  
    invoke  CreateFileA, lpFileName, 80000000h, 1, 0, 3, 80h, 0
    mov     hObject, eax
    .if eax != -1                                      
       invoke  GetFileSize, hObject, 0
       mov     nNumberOfBytesToRead, eax                                   
       mov     esi, eax
       add     esi, 100
       invoke  malloc, esi
       .if eax != 0                 
          mov     edi, eax                 
          invoke  memset, edi, 0, esi
          mov     ecx, pOutMem
          mov     [ecx], edi  
          invoke  ReadFile, hObject, edi, nNumberOfBytesToRead, esp, 0           
          invoke  CloseHandle, hObject
          mov     ecx, pOutSiz
          mov     eax, nNumberOfBytesToRead
          mov     [ecx], eax
          inc     ebx
       .endif
    .endif                                                                    
    mov     eax, ebx
    ret

ReadArray endp

;#############################################

SaveBmpToFile proc uses esi edi ebx  pdata:dword, psize:dword, dwidh:dword, dhigt:dword, pTempl:dword

    LOCAL  bmiHeader       : BITMAPINFOHEADER
    LOCAL  bmfHeader       : BITMAPFILEHEADER
    LOCAL  dwBytesWritten  : dword
    LOCAL  bmp_file_handle : dword
    LOCAL  sFilNamBuf[300h] : byte
    LOCAL  pData            : dword
    
      
    invoke wsprintfA, addr  sFilNamBuf, addr  szdTmpl, addr modname, pTempl
    
    invoke CreateFile, addr  sFilNamBuf, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    mov    bmp_file_handle, eax
        
    mov    ebx, psize  
    add    ebx, sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER  
  
    invoke malloc, ebx
    mov    edi, eax
    mov    pData, eax

    mov    (BITMAPFILEHEADER ptr [edi]).bfOffBits,  sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER    
    mov    (BITMAPFILEHEADER ptr [edi]).bfSize,  ebx    
    mov    (BITMAPFILEHEADER ptr [edi]).bfType,  04D42h
    add    edi, sizeof BITMAPFILEHEADER
    mov    (BITMAPINFOHEADER ptr [edi]).biSize, sizeof BITMAPINFOHEADER
    mov    eax,  dwidh
    mov    (BITMAPINFOHEADER ptr [edi]).biWidth, eax
    mov    eax, dhigt
    neg    eax
    mov    (BITMAPINFOHEADER ptr [edi]).biHeight, eax

    mov    (BITMAPINFOHEADER ptr [edi]).biPlanes, 1
    mov    (BITMAPINFOHEADER ptr [edi]).biBitCount,  32
    mov    (BITMAPINFOHEADER ptr [edi]).biCompression, BI_RGB            
    add    edi, sizeof BITMAPINFOHEADER

    sub    ebx, sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER      

    invoke memcpy, edi, pdata, psize

    add    ebx, sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER
    mov    dwBytesWritten, 0
    invoke WriteFile, bmp_file_handle, pData, ebx, addr dwBytesWritten, 0 
    invoke CloseHandle, bmp_file_handle    
    invoke free, pData
    ret
    
SaveBmpToFile endp    
   
;###########################################################

FrameSaver proc uses esi edi ebx this_:dword
      
      
      mov    esi, this_
      .while (1)
         invoke WaitForSingleObjectEx, mSrv.m_evntNext, -1, FALSE                  
         .if dword ptr mSrv.m_FlFirst == 0
           invoke AddInMvFile1, this_, mSrv.m_CurFrame 
           mov    mSrv.m_FlFirst, 1           
         .elseif dword ptr mSrv.m_FlFirst == 2
            .break
         .else
           invoke AddInMvFile, this_, mSrv.m_DifFrame1  
         .endif
      .endw
      ret


FrameSaver endp

;###########################################################


ClnSaveBmpToFile proc uses esi edi ebx  this_:dword, pdata:dword, pTempl:dword

    LOCAL  bmiHeader       : BITMAPINFOHEADER
    LOCAL  bmfHeader       : BITMAPFILEHEADER
    LOCAL  dwBytesWritten  : dword
    LOCAL  bmp_file_handle : dword
    LOCAL  sFilNamBuf[300h] : byte
    LOCAL  pData            : dword
    
    mov    ebx, this_
    invoke memset, addr bmiHeader, 0, sizeof BITMAPINFOHEADER
    invoke memset, addr bmfHeader, 0, sizeof BITMAPFILEHEADER      
    invoke wsprintfA, addr  sFilNamBuf, addr  szdTmpl, addr modname, pTempl
    
    invoke CreateFile, addr  sFilNamBuf, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    mov    bmp_file_handle, eax
        
    mov    esi, mCln.m_Size ;  mSrv.m_Size psize  
    add    esi, sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER  
  
    invoke malloc, esi
    mov    edi, eax
    mov    pData, eax

    mov    (BITMAPFILEHEADER ptr [edi]).bfOffBits,  sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER    
    mov    (BITMAPFILEHEADER ptr [edi]).bfSize,  esi    
    mov    (BITMAPFILEHEADER ptr [edi]).bfType,  04D42h
    add    edi, sizeof BITMAPFILEHEADER
    mov    (BITMAPINFOHEADER ptr [edi]).biSize, sizeof BITMAPINFOHEADER
    mov    eax, mCln.m_VidInfo.dwWidh   ; dwidh
    mov    (BITMAPINFOHEADER ptr [edi]).biWidth, eax
    mov    eax, mCln.m_VidInfo.dwHeig
    neg    eax
    mov    (BITMAPINFOHEADER ptr [edi]).biHeight, eax

    mov    (BITMAPINFOHEADER ptr [edi]).biPlanes, 1
    mov    (BITMAPINFOHEADER ptr [edi]).biBitCount,  32
    mov    (BITMAPINFOHEADER ptr [edi]).biCompression, BI_RGB            
    add    edi, sizeof BITMAPINFOHEADER
    
    invoke memcpy, edi, pdata, mCln.m_Size

    mov    dwBytesWritten, 0
    invoke WriteFile, bmp_file_handle, pData, esi, addr dwBytesWritten, 0 
    invoke CloseHandle, bmp_file_handle    
    invoke free, pData
    ret
    
ClnSaveBmpToFile endp    
   
;###########################################################



SrvSaveFrameToFile proc uses esi edi ebx  this_:dword, pdata:dword, pTempl:dword

    LOCAL  bmiHeader       : BITMAPINFOHEADER
    LOCAL  bmfHeader       : BITMAPFILEHEADER
    LOCAL  dwBytesWritten  : dword
    LOCAL  bmp_file_handle : dword
    LOCAL  sFilNamBuf[300h] : byte
    LOCAL  pData            : dword
    
    mov    esi, this_
    invoke memset, addr bmiHeader, 0, sizeof BITMAPINFOHEADER
    invoke memset, addr bmfHeader, 0, sizeof BITMAPFILEHEADER
    invoke wsprintfA, addr  sFilNamBuf, addr  szdTmpl, addr modname, pTempl
    
    invoke CreateFile, addr  sFilNamBuf, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    mov    bmp_file_handle, eax
        
    mov    ebx, mSrv.m_Size  ;psize  
    add    ebx, sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER  
  
    invoke malloc, ebx
    mov    edi, eax
    mov    pData, eax

    mov    (BITMAPFILEHEADER ptr [edi]).bfOffBits,  sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER    
    mov    (BITMAPFILEHEADER ptr [edi]).bfSize,  ebx    
    mov    (BITMAPFILEHEADER ptr [edi]).bfType,  04D42h
    add    edi, sizeof BITMAPFILEHEADER
    mov    (BITMAPINFOHEADER ptr [edi]).biSize, sizeof BITMAPINFOHEADER
    mov    eax,  mSrv.m_Widh  ;dwidh
    mov    (BITMAPINFOHEADER ptr [edi]).biWidth, eax
    mov    eax, mSrv.m_Hight   ; dhigt
    neg    eax
    mov    (BITMAPINFOHEADER ptr [edi]).biHeight, eax

    mov    (BITMAPINFOHEADER ptr [edi]).biPlanes, 1
    mov    (BITMAPINFOHEADER ptr [edi]).biBitCount,  32
    mov    (BITMAPINFOHEADER ptr [edi]).biCompression, BI_RGB            
    add    edi, sizeof BITMAPINFOHEADER
    

    invoke memcpy, edi, pdata, mSrv.m_Size

    mov    dwBytesWritten, 0
    invoke WriteFile, bmp_file_handle, pData, ebx, addr dwBytesWritten, 0 
    invoke CloseHandle, bmp_file_handle    
    invoke free, pData
    ret
    
SrvSaveFrameToFile endp    

;#############################################


D3D09SaveFrameToFile proc uses esi edi ebx  this_:dword, pdata:dword, pTempl:dword

    LOCAL  bmiHeader       : BITMAPINFOHEADER
    LOCAL  bmfHeader       : BITMAPFILEHEADER
    LOCAL  dwBytesWritten  : dword
    LOCAL  bmp_file_handle : dword
    LOCAL  sFilNamBuf[300h] : byte
    LOCAL  pData            : dword
    
    mov    esi, this_
    invoke memset, addr bmiHeader, 0, sizeof BITMAPINFOHEADER
    invoke memset, addr bmfHeader, 0, sizeof BITMAPFILEHEADER
    invoke wsprintfA, addr  sFilNamBuf, addr  szdTmpl, addr modname, pTempl
    
    invoke CreateFile, addr  sFilNamBuf, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    mov    bmp_file_handle, eax
        
    mov    ebx, (SERVER_MANAGER ptr [esi]).m_Size
    add    ebx, sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER  
  
    invoke malloc, ebx
    mov    edi, eax
    mov    pData, eax

    mov    (BITMAPFILEHEADER ptr [edi]).bfOffBits,  sizeof BITMAPFILEHEADER + sizeof BITMAPINFOHEADER    
    mov    (BITMAPFILEHEADER ptr [edi]).bfSize,  ebx    
    mov    (BITMAPFILEHEADER ptr [edi]).bfType,  04D42h
    add    edi, sizeof BITMAPFILEHEADER
    mov    (BITMAPINFOHEADER ptr [edi]).biSize, sizeof BITMAPINFOHEADER
    mov    eax,  (SERVER_MANAGER ptr [esi]).m_Widh  
    mov    (BITMAPINFOHEADER ptr [edi]).biWidth, eax
    mov    eax, (SERVER_MANAGER ptr [esi]).m_Hight
    neg    eax
    mov    (BITMAPINFOHEADER ptr [edi]).biHeight, eax

    mov    (BITMAPINFOHEADER ptr [edi]).biPlanes, 1
    mov    (BITMAPINFOHEADER ptr [edi]).biBitCount,  32
    mov    (BITMAPINFOHEADER ptr [edi]).biCompression, BI_RGB            
    add    edi, sizeof BITMAPINFOHEADER
    

    invoke memcpy, edi, pdata, (SERVER_MANAGER ptr [esi]).m_Size

    mov    dwBytesWritten, 0
    invoke WriteFile, bmp_file_handle, pData, ebx, addr dwBytesWritten, 0 
    invoke CloseHandle, bmp_file_handle    
    invoke free, pData
    ret
    
D3D09SaveFrameToFile endp    

;#############################################